from asdl import pybase
from pylib.collections_ import OrderedDict
from typing import Optional, List, Tuple, Dict, Any, cast, TYPE_CHECKING

from _devbuild.gen.id_kind_asdl import Id_t
from _devbuild.gen.id_kind_asdl import Id_str


from asdl import runtime  # For runtime.NO_SPID
from asdl.runtime import NewRecord, NewLeaf
from _devbuild.gen.hnode_asdl import color_e, hnode, hnode_e, hnode_t, Field

class parse_result_e(object):
  EmptyLine = 1
  Eof = 2
  Node = 3

_parse_result_str = {
  1: 'parse_result.EmptyLine',
  2: 'parse_result.Eof',
  3: 'parse_result.Node',
}

def parse_result_str(tag):
  # type: (int) -> str
  return _parse_result_str[tag]

class parse_result_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class parse_result__EmptyLine(parse_result_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result__EmptyLine')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result__EmptyLine')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class parse_result__Eof(parse_result_t):
  _type_tag = 2
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result__Eof')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('parse_result__Eof')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class parse_result(object):
  EmptyLine = parse_result__EmptyLine()
  
  Eof = parse_result__Eof()
  
  class Node(parse_result_t):
    _type_tag = 3
    __slots__ = ('cmd',)
  
    def __init__(self, cmd):
      # type: (command_t) -> None
      self.cmd = cmd
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> parse_result.Node
      return parse_result.Node(cast(command_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('parse_result.Node')
      L = out_node.fields
  
      assert self.cmd is not None
      x0 = self.cmd.PrettyTree()
      L.append(Field('cmd', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('parse_result.Node')
      L = out_node.fields
      assert self.cmd is not None
      x0 = self.cmd.AbbreviatedTree()
      L.append(Field('cmd', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class source_e(object):
  Interactive = 1
  Headless = 2
  Unused = 3
  CFlag = 4
  Stdin = 5
  MainFile = 6
  SourcedFile = 7
  ArgvWord = 8
  Variable = 9
  VarRef = 10
  Alias = 11
  Reparsed = 12
  Synthetic = 13

_source_str = {
  1: 'source.Interactive',
  2: 'source.Headless',
  3: 'source.Unused',
  4: 'source.CFlag',
  5: 'source.Stdin',
  6: 'source.MainFile',
  7: 'source.SourcedFile',
  8: 'source.ArgvWord',
  9: 'source.Variable',
  10: 'source.VarRef',
  11: 'source.Alias',
  12: 'source.Reparsed',
  13: 'source.Synthetic',
}

def source_str(tag):
  # type: (int) -> str
  return _source_str[tag]

class source_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class source__Interactive(source_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source__Interactive')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source__Interactive')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__Headless(source_t):
  _type_tag = 2
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source__Headless')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source__Headless')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source__CFlag(source_t):
  _type_tag = 4
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source__CFlag')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('source__CFlag')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class source(object):
  Interactive = source__Interactive()
  
  Headless = source__Headless()
  
  class Unused(source_t):
    _type_tag = 3
    __slots__ = ('comment',)
  
    def __init__(self, comment):
      # type: (str) -> None
      self.comment = comment
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.Unused
      return source.Unused('')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Unused')
      L = out_node.fields
  
      x0 = NewLeaf(self.comment, color_e.StringConst)
      L.append(Field('comment', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Unused')
      L = out_node.fields
      x0 = NewLeaf(self.comment, color_e.StringConst)
      L.append(Field('comment', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  CFlag = source__CFlag()
  
  class Stdin(source_t):
    _type_tag = 5
    __slots__ = ('comment',)
  
    def __init__(self, comment):
      # type: (str) -> None
      self.comment = comment
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.Stdin
      return source.Stdin('')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Stdin')
      L = out_node.fields
  
      x0 = NewLeaf(self.comment, color_e.StringConst)
      L.append(Field('comment', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Stdin')
      L = out_node.fields
      x0 = NewLeaf(self.comment, color_e.StringConst)
      L.append(Field('comment', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class MainFile(source_t):
    _type_tag = 6
    __slots__ = ('path',)
  
    def __init__(self, path):
      # type: (str) -> None
      self.path = path
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.MainFile
      return source.MainFile('')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.MainFile')
      L = out_node.fields
  
      x0 = NewLeaf(self.path, color_e.StringConst)
      L.append(Field('path', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.MainFile')
      L = out_node.fields
      x0 = NewLeaf(self.path, color_e.StringConst)
      L.append(Field('path', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class SourcedFile(source_t):
    _type_tag = 7
    __slots__ = ('path', 'location')
  
    def __init__(self, path, location):
      # type: (str, loc_t) -> None
      self.path = path
      self.location = location
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.SourcedFile
      return source.SourcedFile('', cast(loc_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.SourcedFile')
      L = out_node.fields
  
      x0 = NewLeaf(self.path, color_e.StringConst)
      L.append(Field('path', x0))
  
      assert self.location is not None
      x1 = self.location.PrettyTree()
      L.append(Field('location', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.SourcedFile')
      L = out_node.fields
      x0 = NewLeaf(self.path, color_e.StringConst)
      L.append(Field('path', x0))
  
      assert self.location is not None
      x1 = self.location.AbbreviatedTree()
      L.append(Field('location', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ArgvWord(source_t):
    _type_tag = 8
    __slots__ = ('what', 'location')
  
    def __init__(self, what, location):
      # type: (str, loc_t) -> None
      self.what = what
      self.location = location
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.ArgvWord
      return source.ArgvWord('', cast(loc_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.ArgvWord')
      L = out_node.fields
  
      x0 = NewLeaf(self.what, color_e.StringConst)
      L.append(Field('what', x0))
  
      assert self.location is not None
      x1 = self.location.PrettyTree()
      L.append(Field('location', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.ArgvWord')
      L = out_node.fields
      x0 = NewLeaf(self.what, color_e.StringConst)
      L.append(Field('what', x0))
  
      assert self.location is not None
      x1 = self.location.AbbreviatedTree()
      L.append(Field('location', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Variable(source_t):
    _type_tag = 9
    __slots__ = ('var_name', 'location')
  
    def __init__(self, var_name, location):
      # type: (str, loc_t) -> None
      self.var_name = var_name
      self.location = location
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.Variable
      return source.Variable('', cast(loc_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Variable')
      L = out_node.fields
  
      x0 = NewLeaf(self.var_name, color_e.StringConst)
      L.append(Field('var_name', x0))
  
      assert self.location is not None
      x1 = self.location.PrettyTree()
      L.append(Field('location', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Variable')
      L = out_node.fields
      x0 = NewLeaf(self.var_name, color_e.StringConst)
      L.append(Field('var_name', x0))
  
      assert self.location is not None
      x1 = self.location.AbbreviatedTree()
      L.append(Field('location', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class VarRef(source_t):
    _type_tag = 10
    __slots__ = ('orig_tok',)
  
    def __init__(self, orig_tok):
      # type: (Token) -> None
      self.orig_tok = orig_tok
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.VarRef
      return source.VarRef(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.VarRef')
      L = out_node.fields
  
      assert self.orig_tok is not None
      x0 = self.orig_tok.PrettyTree()
      L.append(Field('orig_tok', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.VarRef')
      L = out_node.fields
      assert self.orig_tok is not None
      x0 = self.orig_tok.AbbreviatedTree()
      L.append(Field('orig_tok', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Alias(source_t):
    _type_tag = 11
    __slots__ = ('argv0', 'argv0_loc')
  
    def __init__(self, argv0, argv0_loc):
      # type: (str, loc_t) -> None
      self.argv0 = argv0
      self.argv0_loc = argv0_loc
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.Alias
      return source.Alias('', cast(loc_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Alias')
      L = out_node.fields
  
      x0 = NewLeaf(self.argv0, color_e.StringConst)
      L.append(Field('argv0', x0))
  
      assert self.argv0_loc is not None
      x1 = self.argv0_loc.PrettyTree()
      L.append(Field('argv0_loc', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Alias')
      L = out_node.fields
      x0 = NewLeaf(self.argv0, color_e.StringConst)
      L.append(Field('argv0', x0))
  
      assert self.argv0_loc is not None
      x1 = self.argv0_loc.AbbreviatedTree()
      L.append(Field('argv0_loc', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Reparsed(source_t):
    _type_tag = 12
    __slots__ = ('what', 'left_token', 'right_token')
  
    def __init__(self, what, left_token, right_token):
      # type: (str, Token, Token) -> None
      self.what = what
      self.left_token = left_token
      self.right_token = right_token
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.Reparsed
      return source.Reparsed('', cast(Token, None), cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Reparsed')
      L = out_node.fields
  
      x0 = NewLeaf(self.what, color_e.StringConst)
      L.append(Field('what', x0))
  
      assert self.left_token is not None
      x1 = self.left_token.PrettyTree()
      L.append(Field('left_token', x1))
  
      assert self.right_token is not None
      x2 = self.right_token.PrettyTree()
      L.append(Field('right_token', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Reparsed')
      L = out_node.fields
      x0 = NewLeaf(self.what, color_e.StringConst)
      L.append(Field('what', x0))
  
      assert self.left_token is not None
      x1 = self.left_token.AbbreviatedTree()
      L.append(Field('left_token', x1))
  
      assert self.right_token is not None
      x2 = self.right_token.AbbreviatedTree()
      L.append(Field('right_token', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Synthetic(source_t):
    _type_tag = 13
    __slots__ = ('s',)
  
    def __init__(self, s):
      # type: (str) -> None
      self.s = s
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> source.Synthetic
      return source.Synthetic('')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Synthetic')
      L = out_node.fields
  
      x0 = NewLeaf(self.s, color_e.StringConst)
      L.append(Field('s', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('source.Synthetic')
      L = out_node.fields
      x0 = NewLeaf(self.s, color_e.StringConst)
      L.append(Field('s', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class loc_e(object):
  Missing = 1
  Token = 67
  ArgWord = 68
  WordPart = 4
  Word = 5
  Arith = 6
  Command = 7

_loc_str = {
  1: 'loc.Missing',
  4: 'loc.WordPart',
  5: 'loc.Word',
  6: 'loc.Arith',
  7: 'loc.Command',
  67: 'loc.Token',
  68: 'loc.ArgWord',
}

def loc_str(tag):
  # type: (int) -> str
  return _loc_str[tag]

class loc_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class loc__Missing(loc_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc__Missing')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('loc__Missing')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class loc(object):
  Missing = loc__Missing()
  
  class WordPart(loc_t):
    _type_tag = 4
    __slots__ = ('p',)
  
    def __init__(self, p):
      # type: (word_part_t) -> None
      self.p = p
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> loc.WordPart
      return loc.WordPart(cast(word_part_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('loc.WordPart')
      L = out_node.fields
  
      assert self.p is not None
      x0 = self.p.PrettyTree()
      L.append(Field('p', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('loc.WordPart')
      L = out_node.fields
      assert self.p is not None
      x0 = self.p.AbbreviatedTree()
      L.append(Field('p', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Word(loc_t):
    _type_tag = 5
    __slots__ = ('w',)
  
    def __init__(self, w):
      # type: (word_t) -> None
      self.w = w
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> loc.Word
      return loc.Word(cast(word_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('loc.Word')
      L = out_node.fields
  
      assert self.w is not None
      x0 = self.w.PrettyTree()
      L.append(Field('w', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('loc.Word')
      L = out_node.fields
      assert self.w is not None
      x0 = self.w.AbbreviatedTree()
      L.append(Field('w', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Arith(loc_t):
    _type_tag = 6
    __slots__ = ('a',)
  
    def __init__(self, a):
      # type: (arith_expr_t) -> None
      self.a = a
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> loc.Arith
      return loc.Arith(cast(arith_expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('loc.Arith')
      L = out_node.fields
  
      assert self.a is not None
      x0 = self.a.PrettyTree()
      L.append(Field('a', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('loc.Arith')
      L = out_node.fields
      assert self.a is not None
      x0 = self.a.AbbreviatedTree()
      L.append(Field('a', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Command(loc_t):
    _type_tag = 7
    __slots__ = ('c',)
  
    def __init__(self, c):
      # type: (command_t) -> None
      self.c = c
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> loc.Command
      return loc.Command(cast(command_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('loc.Command')
      L = out_node.fields
  
      assert self.c is not None
      x0 = self.c.PrettyTree()
      L.append(Field('c', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('loc.Command')
      L = out_node.fields
      assert self.c is not None
      x0 = self.c.AbbreviatedTree()
      L.append(Field('c', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class debug_frame_e(object):
  Main = 1
  Source = 2
  Call = 3

_debug_frame_str = {
  1: 'debug_frame.Main',
  2: 'debug_frame.Source',
  3: 'debug_frame.Call',
}

def debug_frame_str(tag):
  # type: (int) -> str
  return _debug_frame_str[tag]

class debug_frame_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class debug_frame(object):
  class Main(debug_frame_t):
    _type_tag = 1
    __slots__ = ('dollar0',)
  
    def __init__(self, dollar0):
      # type: (str) -> None
      self.dollar0 = dollar0
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> debug_frame.Main
      return debug_frame.Main('')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('debug_frame.Main')
      L = out_node.fields
  
      x0 = NewLeaf(self.dollar0, color_e.StringConst)
      L.append(Field('dollar0', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('debug_frame.Main')
      L = out_node.fields
      x0 = NewLeaf(self.dollar0, color_e.StringConst)
      L.append(Field('dollar0', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Source(debug_frame_t):
    _type_tag = 2
    __slots__ = ('call_tok', 'source_name')
  
    def __init__(self, call_tok, source_name):
      # type: (Optional[Token], str) -> None
      self.call_tok = call_tok
      self.source_name = source_name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> debug_frame.Source
      return debug_frame.Source(cast('Optional[Token]', None), '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('debug_frame.Source')
      L = out_node.fields
  
      if self.call_tok is not None:  # Optional
        x0 = self.call_tok.PrettyTree()
        L.append(Field('call_tok', x0))
  
      x1 = NewLeaf(self.source_name, color_e.StringConst)
      L.append(Field('source_name', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('debug_frame.Source')
      L = out_node.fields
      if self.call_tok is not None:  # Optional
        x0 = self.call_tok.AbbreviatedTree()
        L.append(Field('call_tok', x0))
  
      x1 = NewLeaf(self.source_name, color_e.StringConst)
      L.append(Field('source_name', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Call(debug_frame_t):
    _type_tag = 3
    __slots__ = ('call_tok', 'def_tok', 'func_name')
  
    def __init__(self, call_tok, def_tok, func_name):
      # type: (Optional[Token], Token, str) -> None
      self.call_tok = call_tok
      self.def_tok = def_tok
      self.func_name = func_name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> debug_frame.Call
      return debug_frame.Call(cast('Optional[Token]', None), cast(Token, None),
                              '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('debug_frame.Call')
      L = out_node.fields
  
      if self.call_tok is not None:  # Optional
        x0 = self.call_tok.PrettyTree()
        L.append(Field('call_tok', x0))
  
      assert self.def_tok is not None
      x1 = self.def_tok.PrettyTree()
      L.append(Field('def_tok', x1))
  
      x2 = NewLeaf(self.func_name, color_e.StringConst)
      L.append(Field('func_name', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('debug_frame.Call')
      L = out_node.fields
      if self.call_tok is not None:  # Optional
        x0 = self.call_tok.AbbreviatedTree()
        L.append(Field('call_tok', x0))
  
      assert self.def_tok is not None
      x1 = self.def_tok.AbbreviatedTree()
      L.append(Field('def_tok', x1))
  
      x2 = NewLeaf(self.func_name, color_e.StringConst)
      L.append(Field('func_name', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class bracket_op_e(object):
  WholeArray = 1
  ArrayIndex = 2

_bracket_op_str = {
  1: 'bracket_op.WholeArray',
  2: 'bracket_op.ArrayIndex',
}

def bracket_op_str(tag):
  # type: (int) -> str
  return _bracket_op_str[tag]

class bracket_op_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class bracket_op(object):
  class WholeArray(bracket_op_t):
    _type_tag = 1
    __slots__ = ('op_id',)
  
    def __init__(self, op_id):
      # type: (Id_t) -> None
      self.op_id = op_id
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> bracket_op.WholeArray
      return bracket_op.WholeArray(-1)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bracket_op.WholeArray')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bracket_op.WholeArray')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ArrayIndex(bracket_op_t):
    _type_tag = 2
    __slots__ = ('expr',)
  
    def __init__(self, expr):
      # type: (arith_expr_t) -> None
      self.expr = expr
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> bracket_op.ArrayIndex
      return bracket_op.ArrayIndex(cast(arith_expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bracket_op.ArrayIndex')
      L = out_node.fields
  
      assert self.expr is not None
      x0 = self.expr.PrettyTree()
      L.append(Field('expr', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bracket_op.ArrayIndex')
      L = out_node.fields
      assert self.expr is not None
      x0 = self.expr.AbbreviatedTree()
      L.append(Field('expr', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class suffix_op_e(object):
  Nullary = 67
  Unary = 2
  Static = 3
  PatSub = 4
  Slice = 5

_suffix_op_str = {
  2: 'suffix_op.Unary',
  3: 'suffix_op.Static',
  4: 'suffix_op.PatSub',
  5: 'suffix_op.Slice',
  67: 'suffix_op.Nullary',
}

def suffix_op_str(tag):
  # type: (int) -> str
  return _suffix_op_str[tag]

class suffix_op_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class suffix_op(object):
  class Unary(suffix_op_t):
    _type_tag = 2
    __slots__ = ('op', 'arg_word')
  
    def __init__(self, op, arg_word):
      # type: (Token, rhs_word_t) -> None
      self.op = op
      self.arg_word = arg_word
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> suffix_op.Unary
      return suffix_op.Unary(cast(Token, None), cast(rhs_word_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('suffix_op.Unary')
      L = out_node.fields
  
      assert self.op is not None
      x0 = self.op.PrettyTree()
      L.append(Field('op', x0))
  
      assert self.arg_word is not None
      x1 = self.arg_word.PrettyTree()
      L.append(Field('arg_word', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('suffix_op.Unary')
      L = out_node.fields
      assert self.op is not None
      x0 = self.op.AbbreviatedTree()
      L.append(Field('op', x0))
  
      assert self.arg_word is not None
      x1 = self.arg_word.AbbreviatedTree()
      L.append(Field('arg_word', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Static(suffix_op_t):
    _type_tag = 3
    __slots__ = ('tok', 'arg')
  
    def __init__(self, tok, arg):
      # type: (Token, str) -> None
      self.tok = tok
      self.arg = arg
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> suffix_op.Static
      return suffix_op.Static(cast(Token, None), '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('suffix_op.Static')
      L = out_node.fields
  
      assert self.tok is not None
      x0 = self.tok.PrettyTree()
      L.append(Field('tok', x0))
  
      x1 = NewLeaf(self.arg, color_e.StringConst)
      L.append(Field('arg', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('suffix_op.Static')
      L = out_node.fields
      assert self.tok is not None
      x0 = self.tok.AbbreviatedTree()
      L.append(Field('tok', x0))
  
      x1 = NewLeaf(self.arg, color_e.StringConst)
      L.append(Field('arg', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class PatSub(suffix_op_t):
    _type_tag = 4
    __slots__ = ('pat', 'replace', 'replace_mode', 'slash_tok')
  
    def __init__(self, pat, replace, replace_mode, slash_tok):
      # type: (CompoundWord, rhs_word_t, Id_t, Token) -> None
      self.pat = pat
      self.replace = replace
      self.replace_mode = replace_mode
      self.slash_tok = slash_tok
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> suffix_op.PatSub
      return suffix_op.PatSub(cast(CompoundWord, None), cast(rhs_word_t, None),
                              -1, cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('suffix_op.PatSub')
      L = out_node.fields
  
      assert self.pat is not None
      x0 = self.pat.PrettyTree()
      L.append(Field('pat', x0))
  
      assert self.replace is not None
      x1 = self.replace.PrettyTree()
      L.append(Field('replace', x1))
  
      x2 = hnode.Leaf(Id_str(self.replace_mode), color_e.UserType)
      L.append(Field('replace_mode', x2))
  
      assert self.slash_tok is not None
      x3 = self.slash_tok.PrettyTree()
      L.append(Field('slash_tok', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('suffix_op.PatSub')
      L = out_node.fields
      assert self.pat is not None
      x0 = self.pat.AbbreviatedTree()
      L.append(Field('pat', x0))
  
      assert self.replace is not None
      x1 = self.replace.AbbreviatedTree()
      L.append(Field('replace', x1))
  
      x2 = hnode.Leaf(Id_str(self.replace_mode), color_e.UserType)
      L.append(Field('replace_mode', x2))
  
      assert self.slash_tok is not None
      x3 = self.slash_tok.AbbreviatedTree()
      L.append(Field('slash_tok', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Slice(suffix_op_t):
    _type_tag = 5
    __slots__ = ('begin', 'length')
  
    def __init__(self, begin, length):
      # type: (Optional[arith_expr_t], Optional[arith_expr_t]) -> None
      self.begin = begin
      self.length = length
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> suffix_op.Slice
      return suffix_op.Slice(cast('Optional[arith_expr_t]', None),
                             cast('Optional[arith_expr_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('suffix_op.Slice')
      L = out_node.fields
  
      if self.begin is not None:  # Optional
        x0 = self.begin.PrettyTree()
        L.append(Field('begin', x0))
  
      if self.length is not None:  # Optional
        x1 = self.length.PrettyTree()
        L.append(Field('length', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('suffix_op.Slice')
      L = out_node.fields
      if self.begin is not None:  # Optional
        x0 = self.begin.AbbreviatedTree()
        L.append(Field('begin', x0))
  
      if self.length is not None:  # Optional
        x1 = self.length.AbbreviatedTree()
        L.append(Field('length', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class word_part_e(object):
  ShArrayLiteral = 74
  BashAssocLiteral = 2
  Literal = 67
  EscapedLiteral = 4
  SingleQuoted = 71
  DoubleQuoted = 70
  SimpleVarSub = 72
  BracedVarSub = 69
  CommandSub = 73
  TildeSub = 10
  ArithSub = 11
  BracedTuple = 12
  BracedRange = 13
  ExtGlob = 14
  Splice = 15
  ExprSub = 16

_word_part_str = {
  2: 'word_part.BashAssocLiteral',
  4: 'word_part.EscapedLiteral',
  10: 'word_part.TildeSub',
  11: 'word_part.ArithSub',
  12: 'word_part.BracedTuple',
  13: 'word_part.BracedRange',
  14: 'word_part.ExtGlob',
  15: 'word_part.Splice',
  16: 'word_part.ExprSub',
  67: 'word_part.Literal',
  69: 'word_part.BracedVarSub',
  70: 'word_part.DoubleQuoted',
  71: 'word_part.SingleQuoted',
  72: 'word_part.SimpleVarSub',
  73: 'word_part.CommandSub',
  74: 'word_part.ShArrayLiteral',
}

def word_part_str(tag):
  # type: (int) -> str
  return _word_part_str[tag]

class word_part_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class word_part(object):
  class BashAssocLiteral(word_part_t):
    _type_tag = 2
    __slots__ = ('left', 'pairs', 'right')
  
    def __init__(self, left, pairs, right):
      # type: (Token, List[AssocPair], Token) -> None
      self.left = left
      self.pairs = pairs
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.BashAssocLiteral
      return word_part.BashAssocLiteral(cast(Token, None), [] if alloc_lists
                                        else cast('List[AssocPair]', None),
                                        cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.BashAssocLiteral')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      if self.pairs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.pairs:
          x1.children.append(i1.PrettyTree())
        L.append(Field('pairs', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.BashAssocLiteral')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      if self.pairs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.pairs:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('pairs', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class EscapedLiteral(word_part_t):
    _type_tag = 4
    __slots__ = ('token', 'ch')
  
    def __init__(self, token, ch):
      # type: (Token, str) -> None
      self.token = token
      self.ch = ch
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.EscapedLiteral
      return word_part.EscapedLiteral(cast(Token, None), '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.EscapedLiteral')
      L = out_node.fields
  
      assert self.token is not None
      x0 = self.token.PrettyTree()
      L.append(Field('token', x0))
  
      x1 = NewLeaf(self.ch, color_e.StringConst)
      L.append(Field('ch', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.EscapedLiteral')
      L = out_node.fields
      assert self.token is not None
      x0 = self.token.AbbreviatedTree()
      L.append(Field('token', x0))
  
      x1 = NewLeaf(self.ch, color_e.StringConst)
      L.append(Field('ch', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class TildeSub(word_part_t):
    _type_tag = 10
    __slots__ = ('token', 'user_name')
  
    def __init__(self, token, user_name):
      # type: (Token, Optional[str]) -> None
      self.token = token
      self.user_name = user_name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.TildeSub
      return word_part.TildeSub(cast(Token, None), cast('Optional[str]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.TildeSub')
      L = out_node.fields
  
      assert self.token is not None
      x0 = self.token.PrettyTree()
      L.append(Field('token', x0))
  
      if self.user_name is not None:  # Optional
        x1 = NewLeaf(self.user_name, color_e.StringConst)
        L.append(Field('user_name', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.TildeSub')
      L = out_node.fields
      assert self.token is not None
      x0 = self.token.AbbreviatedTree()
      L.append(Field('token', x0))
  
      if self.user_name is not None:  # Optional
        x1 = NewLeaf(self.user_name, color_e.StringConst)
        L.append(Field('user_name', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ArithSub(word_part_t):
    _type_tag = 11
    __slots__ = ('left', 'anode', 'right')
  
    def __init__(self, left, anode, right):
      # type: (Token, arith_expr_t, Token) -> None
      self.left = left
      self.anode = anode
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.ArithSub
      return word_part.ArithSub(cast(Token, None), cast(arith_expr_t, None),
                                cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.ArithSub')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      assert self.anode is not None
      x1 = self.anode.PrettyTree()
      L.append(Field('anode', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.ArithSub')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      assert self.anode is not None
      x1 = self.anode.AbbreviatedTree()
      L.append(Field('anode', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class BracedTuple(word_part_t):
    _type_tag = 12
    __slots__ = ('words',)
  
    def __init__(self, words):
      # type: (List[CompoundWord]) -> None
      self.words = words
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.BracedTuple
      return word_part.BracedTuple([] if alloc_lists else
                                   cast('List[CompoundWord]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.BracedTuple')
      L = out_node.fields
  
      if self.words is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.words:
          x0.children.append(i0.PrettyTree())
        L.append(Field('words', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.BracedTuple')
      L = out_node.fields
      if self.words is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.words:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('words', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class BracedRange(word_part_t):
    _type_tag = 13
    __slots__ = ('blame_tok', 'kind', 'start', 'end', 'step')
  
    def __init__(self, blame_tok, kind, start, end, step):
      # type: (Token, Id_t, str, str, int) -> None
      self.blame_tok = blame_tok
      self.kind = kind
      self.start = start
      self.end = end
      self.step = step
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.BracedRange
      return word_part.BracedRange(cast(Token, None), -1, '', '', -1)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.BracedRange')
      L = out_node.fields
  
      assert self.blame_tok is not None
      x0 = self.blame_tok.PrettyTree()
      L.append(Field('blame_tok', x0))
  
      x1 = hnode.Leaf(Id_str(self.kind), color_e.UserType)
      L.append(Field('kind', x1))
  
      x2 = NewLeaf(self.start, color_e.StringConst)
      L.append(Field('start', x2))
  
      x3 = NewLeaf(self.end, color_e.StringConst)
      L.append(Field('end', x3))
  
      x4 = hnode.Leaf(str(self.step), color_e.OtherConst)
      L.append(Field('step', x4))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.BracedRange')
      L = out_node.fields
      assert self.blame_tok is not None
      x0 = self.blame_tok.AbbreviatedTree()
      L.append(Field('blame_tok', x0))
  
      x1 = hnode.Leaf(Id_str(self.kind), color_e.UserType)
      L.append(Field('kind', x1))
  
      x2 = NewLeaf(self.start, color_e.StringConst)
      L.append(Field('start', x2))
  
      x3 = NewLeaf(self.end, color_e.StringConst)
      L.append(Field('end', x3))
  
      x4 = hnode.Leaf(str(self.step), color_e.OtherConst)
      L.append(Field('step', x4))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ExtGlob(word_part_t):
    _type_tag = 14
    __slots__ = ('op', 'arms', 'right')
  
    def __init__(self, op, arms, right):
      # type: (Token, List[CompoundWord], Token) -> None
      self.op = op
      self.arms = arms
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.ExtGlob
      return word_part.ExtGlob(cast(Token, None), [] if alloc_lists else
                               cast('List[CompoundWord]', None), cast(Token,
                               None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.ExtGlob')
      L = out_node.fields
  
      assert self.op is not None
      x0 = self.op.PrettyTree()
      L.append(Field('op', x0))
  
      if self.arms is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.arms:
          x1.children.append(i1.PrettyTree())
        L.append(Field('arms', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.ExtGlob')
      L = out_node.fields
      assert self.op is not None
      x0 = self.op.AbbreviatedTree()
      L.append(Field('op', x0))
  
      if self.arms is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.arms:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('arms', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Splice(word_part_t):
    _type_tag = 15
    __slots__ = ('blame_tok', 'var_name')
  
    def __init__(self, blame_tok, var_name):
      # type: (Token, str) -> None
      self.blame_tok = blame_tok
      self.var_name = var_name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.Splice
      return word_part.Splice(cast(Token, None), '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.Splice')
      L = out_node.fields
  
      assert self.blame_tok is not None
      x0 = self.blame_tok.PrettyTree()
      L.append(Field('blame_tok', x0))
  
      x1 = NewLeaf(self.var_name, color_e.StringConst)
      L.append(Field('var_name', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.Splice')
      L = out_node.fields
      assert self.blame_tok is not None
      x0 = self.blame_tok.AbbreviatedTree()
      L.append(Field('blame_tok', x0))
  
      x1 = NewLeaf(self.var_name, color_e.StringConst)
      L.append(Field('var_name', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ExprSub(word_part_t):
    _type_tag = 16
    __slots__ = ('left', 'child', 'right')
  
    def __init__(self, left, child, right):
      # type: (Token, expr_t, Token) -> None
      self.left = left
      self.child = child
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word_part.ExprSub
      return word_part.ExprSub(cast(Token, None), cast(expr_t, None),
                               cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.ExprSub')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      assert self.child is not None
      x1 = self.child.PrettyTree()
      L.append(Field('child', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word_part.ExprSub')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      assert self.child is not None
      x1 = self.child.AbbreviatedTree()
      L.append(Field('child', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class rhs_word_e(object):
  Empty = 1
  Compound = 68

_rhs_word_str = {
  1: 'rhs_word.Empty',
  68: 'rhs_word.Compound',
}

def rhs_word_str(tag):
  # type: (int) -> str
  return _rhs_word_str[tag]

class rhs_word_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class rhs_word__Empty(rhs_word_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('rhs_word__Empty')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('rhs_word__Empty')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class rhs_word(object):
  Empty = rhs_word__Empty()
  

class word_e(object):
  Operator = 67
  Compound = 68
  BracedTree = 3
  String = 4

_word_str = {
  3: 'word.BracedTree',
  4: 'word.String',
  67: 'word.Operator',
  68: 'word.Compound',
}

def word_str(tag):
  # type: (int) -> str
  return _word_str[tag]

class word_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class word(object):
  class BracedTree(word_t):
    _type_tag = 3
    __slots__ = ('parts',)
  
    def __init__(self, parts):
      # type: (List[word_part_t]) -> None
      self.parts = parts
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word.BracedTree
      return word.BracedTree([] if alloc_lists else cast('List[word_part_t]',
                             None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word.BracedTree')
      L = out_node.fields
  
      if self.parts is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.parts:
          x0.children.append(i0.PrettyTree())
        L.append(Field('parts', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word.BracedTree')
      L = out_node.fields
      if self.parts is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.parts:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('parts', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class String(word_t):
    _type_tag = 4
    __slots__ = ('id', 's', 'blame_loc')
  
    def __init__(self, id, s, blame_loc):
      # type: (Id_t, str, Optional[CompoundWord]) -> None
      self.id = id
      self.s = s
      self.blame_loc = blame_loc
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> word.String
      return word.String(-1, '', cast('Optional[CompoundWord]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word.String')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
      L.append(Field('id', x0))
  
      x1 = NewLeaf(self.s, color_e.StringConst)
      L.append(Field('s', x1))
  
      if self.blame_loc is not None:  # Optional
        x2 = self.blame_loc.PrettyTree()
        L.append(Field('blame_loc', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('word.String')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
      L.append(Field('id', x0))
  
      x1 = NewLeaf(self.s, color_e.StringConst)
      L.append(Field('s', x1))
  
      if self.blame_loc is not None:  # Optional
        x2 = self.blame_loc.AbbreviatedTree()
        L.append(Field('blame_loc', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class sh_lhs_expr_e(object):
  Name = 1
  IndexedName = 2
  UnparsedIndex = 3

_sh_lhs_expr_str = {
  1: 'sh_lhs_expr.Name',
  2: 'sh_lhs_expr.IndexedName',
  3: 'sh_lhs_expr.UnparsedIndex',
}

def sh_lhs_expr_str(tag):
  # type: (int) -> str
  return _sh_lhs_expr_str[tag]

class sh_lhs_expr_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class sh_lhs_expr(object):
  class Name(sh_lhs_expr_t):
    _type_tag = 1
    __slots__ = ('left', 'name')
  
    def __init__(self, left, name):
      # type: (Token, str) -> None
      self.left = left
      self.name = name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> sh_lhs_expr.Name
      return sh_lhs_expr.Name(cast(Token, None), '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('sh_lhs_expr.Name')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      x1 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('sh_lhs_expr.Name')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      x1 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class IndexedName(sh_lhs_expr_t):
    _type_tag = 2
    __slots__ = ('left', 'name', 'index')
  
    def __init__(self, left, name, index):
      # type: (Token, str, arith_expr_t) -> None
      self.left = left
      self.name = name
      self.index = index
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> sh_lhs_expr.IndexedName
      return sh_lhs_expr.IndexedName(cast(Token, None), '', cast(arith_expr_t,
                                     None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('sh_lhs_expr.IndexedName')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      x1 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x1))
  
      assert self.index is not None
      x2 = self.index.PrettyTree()
      L.append(Field('index', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('sh_lhs_expr.IndexedName')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      x1 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x1))
  
      assert self.index is not None
      x2 = self.index.AbbreviatedTree()
      L.append(Field('index', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class UnparsedIndex(sh_lhs_expr_t):
    _type_tag = 3
    __slots__ = ('left', 'name', 'index')
  
    def __init__(self, left, name, index):
      # type: (Token, str, str) -> None
      self.left = left
      self.name = name
      self.index = index
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> sh_lhs_expr.UnparsedIndex
      return sh_lhs_expr.UnparsedIndex(cast(Token, None), '', '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('sh_lhs_expr.UnparsedIndex')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      x1 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x1))
  
      x2 = NewLeaf(self.index, color_e.StringConst)
      L.append(Field('index', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('sh_lhs_expr.UnparsedIndex')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      x1 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x1))
  
      x2 = NewLeaf(self.index, color_e.StringConst)
      L.append(Field('index', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class arith_expr_e(object):
  VarSub = 72
  Word = 68
  UnaryAssign = 3
  BinaryAssign = 4
  Unary = 5
  Binary = 6
  TernaryOp = 7

_arith_expr_str = {
  3: 'arith_expr.UnaryAssign',
  4: 'arith_expr.BinaryAssign',
  5: 'arith_expr.Unary',
  6: 'arith_expr.Binary',
  7: 'arith_expr.TernaryOp',
  68: 'arith_expr.Word',
  72: 'arith_expr.VarSub',
}

def arith_expr_str(tag):
  # type: (int) -> str
  return _arith_expr_str[tag]

class arith_expr_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class arith_expr(object):
  class UnaryAssign(arith_expr_t):
    _type_tag = 3
    __slots__ = ('op_id', 'child')
  
    def __init__(self, op_id, child):
      # type: (Id_t, arith_expr_t) -> None
      self.op_id = op_id
      self.child = child
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> arith_expr.UnaryAssign
      return arith_expr.UnaryAssign(-1, cast(arith_expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.UnaryAssign')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.child is not None
      x1 = self.child.PrettyTree()
      L.append(Field('child', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.UnaryAssign')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.child is not None
      x1 = self.child.AbbreviatedTree()
      L.append(Field('child', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class BinaryAssign(arith_expr_t):
    _type_tag = 4
    __slots__ = ('op_id', 'left', 'right')
  
    def __init__(self, op_id, left, right):
      # type: (Id_t, arith_expr_t, arith_expr_t) -> None
      self.op_id = op_id
      self.left = left
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> arith_expr.BinaryAssign
      return arith_expr.BinaryAssign(-1, cast(arith_expr_t, None),
                                     cast(arith_expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.BinaryAssign')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.left is not None
      x1 = self.left.PrettyTree()
      L.append(Field('left', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.BinaryAssign')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.left is not None
      x1 = self.left.AbbreviatedTree()
      L.append(Field('left', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Unary(arith_expr_t):
    _type_tag = 5
    __slots__ = ('op_id', 'child')
  
    def __init__(self, op_id, child):
      # type: (Id_t, arith_expr_t) -> None
      self.op_id = op_id
      self.child = child
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> arith_expr.Unary
      return arith_expr.Unary(-1, cast(arith_expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.Unary')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.child is not None
      x1 = self.child.PrettyTree()
      L.append(Field('child', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.Unary')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.child is not None
      x1 = self.child.AbbreviatedTree()
      L.append(Field('child', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Binary(arith_expr_t):
    _type_tag = 6
    __slots__ = ('op_id', 'left', 'right')
  
    def __init__(self, op_id, left, right):
      # type: (Id_t, arith_expr_t, arith_expr_t) -> None
      self.op_id = op_id
      self.left = left
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> arith_expr.Binary
      return arith_expr.Binary(-1, cast(arith_expr_t, None), cast(arith_expr_t,
                               None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.Binary')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.left is not None
      x1 = self.left.PrettyTree()
      L.append(Field('left', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.Binary')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.left is not None
      x1 = self.left.AbbreviatedTree()
      L.append(Field('left', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class TernaryOp(arith_expr_t):
    _type_tag = 7
    __slots__ = ('cond', 'true_expr', 'false_expr')
  
    def __init__(self, cond, true_expr, false_expr):
      # type: (arith_expr_t, arith_expr_t, arith_expr_t) -> None
      self.cond = cond
      self.true_expr = true_expr
      self.false_expr = false_expr
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> arith_expr.TernaryOp
      return arith_expr.TernaryOp(cast(arith_expr_t, None), cast(arith_expr_t,
                                  None), cast(arith_expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.TernaryOp')
      L = out_node.fields
  
      assert self.cond is not None
      x0 = self.cond.PrettyTree()
      L.append(Field('cond', x0))
  
      assert self.true_expr is not None
      x1 = self.true_expr.PrettyTree()
      L.append(Field('true_expr', x1))
  
      assert self.false_expr is not None
      x2 = self.false_expr.PrettyTree()
      L.append(Field('false_expr', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('arith_expr.TernaryOp')
      L = out_node.fields
      assert self.cond is not None
      x0 = self.cond.AbbreviatedTree()
      L.append(Field('cond', x0))
  
      assert self.true_expr is not None
      x1 = self.true_expr.AbbreviatedTree()
      L.append(Field('true_expr', x1))
  
      assert self.false_expr is not None
      x2 = self.false_expr.AbbreviatedTree()
      L.append(Field('false_expr', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class bool_expr_e(object):
  WordTest = 1
  Binary = 2
  Unary = 3
  LogicalNot = 4
  LogicalAnd = 5
  LogicalOr = 6

_bool_expr_str = {
  1: 'bool_expr.WordTest',
  2: 'bool_expr.Binary',
  3: 'bool_expr.Unary',
  4: 'bool_expr.LogicalNot',
  5: 'bool_expr.LogicalAnd',
  6: 'bool_expr.LogicalOr',
}

def bool_expr_str(tag):
  # type: (int) -> str
  return _bool_expr_str[tag]

class bool_expr_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class bool_expr(object):
  class WordTest(bool_expr_t):
    _type_tag = 1
    __slots__ = ('w',)
  
    def __init__(self, w):
      # type: (word_t) -> None
      self.w = w
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> bool_expr.WordTest
      return bool_expr.WordTest(cast(word_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.WordTest')
      L = out_node.fields
  
      assert self.w is not None
      x0 = self.w.PrettyTree()
      L.append(Field('w', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.WordTest')
      L = out_node.fields
      assert self.w is not None
      x0 = self.w.AbbreviatedTree()
      L.append(Field('w', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Binary(bool_expr_t):
    _type_tag = 2
    __slots__ = ('op_id', 'left', 'right')
  
    def __init__(self, op_id, left, right):
      # type: (Id_t, word_t, word_t) -> None
      self.op_id = op_id
      self.left = left
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> bool_expr.Binary
      return bool_expr.Binary(-1, cast(word_t, None), cast(word_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.Binary')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.left is not None
      x1 = self.left.PrettyTree()
      L.append(Field('left', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.Binary')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.left is not None
      x1 = self.left.AbbreviatedTree()
      L.append(Field('left', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Unary(bool_expr_t):
    _type_tag = 3
    __slots__ = ('op_id', 'child')
  
    def __init__(self, op_id, child):
      # type: (Id_t, word_t) -> None
      self.op_id = op_id
      self.child = child
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> bool_expr.Unary
      return bool_expr.Unary(-1, cast(word_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.Unary')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.child is not None
      x1 = self.child.PrettyTree()
      L.append(Field('child', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.Unary')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      assert self.child is not None
      x1 = self.child.AbbreviatedTree()
      L.append(Field('child', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class LogicalNot(bool_expr_t):
    _type_tag = 4
    __slots__ = ('child',)
  
    def __init__(self, child):
      # type: (bool_expr_t) -> None
      self.child = child
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> bool_expr.LogicalNot
      return bool_expr.LogicalNot(cast(bool_expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.LogicalNot')
      L = out_node.fields
  
      assert self.child is not None
      x0 = self.child.PrettyTree()
      L.append(Field('child', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.LogicalNot')
      L = out_node.fields
      assert self.child is not None
      x0 = self.child.AbbreviatedTree()
      L.append(Field('child', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class LogicalAnd(bool_expr_t):
    _type_tag = 5
    __slots__ = ('left', 'right')
  
    def __init__(self, left, right):
      # type: (bool_expr_t, bool_expr_t) -> None
      self.left = left
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> bool_expr.LogicalAnd
      return bool_expr.LogicalAnd(cast(bool_expr_t, None), cast(bool_expr_t,
                                  None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.LogicalAnd')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      assert self.right is not None
      x1 = self.right.PrettyTree()
      L.append(Field('right', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.LogicalAnd')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      assert self.right is not None
      x1 = self.right.AbbreviatedTree()
      L.append(Field('right', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class LogicalOr(bool_expr_t):
    _type_tag = 6
    __slots__ = ('left', 'right')
  
    def __init__(self, left, right):
      # type: (bool_expr_t, bool_expr_t) -> None
      self.left = left
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> bool_expr.LogicalOr
      return bool_expr.LogicalOr(cast(bool_expr_t, None), cast(bool_expr_t,
                                 None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.LogicalOr')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      assert self.right is not None
      x1 = self.right.PrettyTree()
      L.append(Field('right', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('bool_expr.LogicalOr')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      assert self.right is not None
      x1 = self.right.AbbreviatedTree()
      L.append(Field('right', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class redir_loc_e(object):
  Fd = 1
  VarName = 2

_redir_loc_str = {
  1: 'redir_loc.Fd',
  2: 'redir_loc.VarName',
}

def redir_loc_str(tag):
  # type: (int) -> str
  return _redir_loc_str[tag]

class redir_loc_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class redir_loc(object):
  class Fd(redir_loc_t):
    _type_tag = 1
    __slots__ = ('fd',)
  
    def __init__(self, fd):
      # type: (int) -> None
      self.fd = fd
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> redir_loc.Fd
      return redir_loc.Fd(-1)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('redir_loc.Fd')
      L = out_node.fields
  
      x0 = hnode.Leaf(str(self.fd), color_e.OtherConst)
      L.append(Field('fd', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('redir_loc.Fd')
      L = out_node.fields
      x0 = hnode.Leaf(str(self.fd), color_e.OtherConst)
      L.append(Field('fd', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class VarName(redir_loc_t):
    _type_tag = 2
    __slots__ = ('name',)
  
    def __init__(self, name):
      # type: (str) -> None
      self.name = name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> redir_loc.VarName
      return redir_loc.VarName('')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('redir_loc.VarName')
      L = out_node.fields
  
      x0 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('redir_loc.VarName')
      L = out_node.fields
      x0 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class redir_param_e(object):
  Word = 68
  HereDoc = 2

_redir_param_str = {
  2: 'redir_param.HereDoc',
  68: 'redir_param.Word',
}

def redir_param_str(tag):
  # type: (int) -> str
  return _redir_param_str[tag]

class redir_param_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class redir_param(object):
  class HereDoc(redir_param_t):
    _type_tag = 2
    __slots__ = ('here_begin', 'here_end_tok', 'stdin_parts')
  
    def __init__(self, here_begin, here_end_tok, stdin_parts):
      # type: (word_t, Optional[Token], List[word_part_t]) -> None
      self.here_begin = here_begin
      self.here_end_tok = here_end_tok
      self.stdin_parts = stdin_parts
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> redir_param.HereDoc
      return redir_param.HereDoc(cast(word_t, None), cast('Optional[Token]',
                                 None), [] if alloc_lists else
                                 cast('List[word_part_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('redir_param.HereDoc')
      L = out_node.fields
  
      assert self.here_begin is not None
      x0 = self.here_begin.PrettyTree()
      L.append(Field('here_begin', x0))
  
      if self.here_end_tok is not None:  # Optional
        x1 = self.here_end_tok.PrettyTree()
        L.append(Field('here_end_tok', x1))
  
      if self.stdin_parts is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.stdin_parts:
          x2.children.append(i2.PrettyTree())
        L.append(Field('stdin_parts', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('redir_param.HereDoc')
      L = out_node.fields
      assert self.here_begin is not None
      x0 = self.here_begin.AbbreviatedTree()
      L.append(Field('here_begin', x0))
  
      if self.here_end_tok is not None:  # Optional
        x1 = self.here_end_tok.AbbreviatedTree()
        L.append(Field('here_end_tok', x1))
  
      if self.stdin_parts is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.stdin_parts:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('stdin_parts', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class assign_op_t(pybase.SimpleObj):
  pass

class assign_op_e(object):
  Equal = assign_op_t(1)
  PlusEqual = assign_op_t(2)

_assign_op_str = {
  1: 'assign_op.Equal',
  2: 'assign_op.PlusEqual',
}

def assign_op_str(val):
  # type: (assign_op_t) -> str
  return _assign_op_str[val]

class condition_e(object):
  Shell = 1
  YshExpr = 2

_condition_str = {
  1: 'condition.Shell',
  2: 'condition.YshExpr',
}

def condition_str(tag):
  # type: (int) -> str
  return _condition_str[tag]

class condition_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class condition(object):
  class Shell(condition_t):
    _type_tag = 1
    __slots__ = ('commands',)
  
    def __init__(self, commands):
      # type: (List[command_t]) -> None
      self.commands = commands
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> condition.Shell
      return condition.Shell([] if alloc_lists else cast('List[command_t]',
                             None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('condition.Shell')
      L = out_node.fields
  
      if self.commands is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.commands:
          x0.children.append(i0.PrettyTree())
        L.append(Field('commands', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('condition.Shell')
      L = out_node.fields
      if self.commands is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.commands:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('commands', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class YshExpr(condition_t):
    _type_tag = 2
    __slots__ = ('e',)
  
    def __init__(self, e):
      # type: (expr_t) -> None
      self.e = e
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> condition.YshExpr
      return condition.YshExpr(cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('condition.YshExpr')
      L = out_node.fields
  
      assert self.e is not None
      x0 = self.e.PrettyTree()
      L.append(Field('e', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('condition.YshExpr')
      L = out_node.fields
      assert self.e is not None
      x0 = self.e.AbbreviatedTree()
      L.append(Field('e', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class case_arg_e(object):
  Word = 1
  YshExpr = 2

_case_arg_str = {
  1: 'case_arg.Word',
  2: 'case_arg.YshExpr',
}

def case_arg_str(tag):
  # type: (int) -> str
  return _case_arg_str[tag]

class case_arg_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class case_arg(object):
  class Word(case_arg_t):
    _type_tag = 1
    __slots__ = ('w',)
  
    def __init__(self, w):
      # type: (word_t) -> None
      self.w = w
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> case_arg.Word
      return case_arg.Word(cast(word_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('case_arg.Word')
      L = out_node.fields
  
      assert self.w is not None
      x0 = self.w.PrettyTree()
      L.append(Field('w', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('case_arg.Word')
      L = out_node.fields
      assert self.w is not None
      x0 = self.w.AbbreviatedTree()
      L.append(Field('w', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class YshExpr(case_arg_t):
    _type_tag = 2
    __slots__ = ('e',)
  
    def __init__(self, e):
      # type: (expr_t) -> None
      self.e = e
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> case_arg.YshExpr
      return case_arg.YshExpr(cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('case_arg.YshExpr')
      L = out_node.fields
  
      assert self.e is not None
      x0 = self.e.PrettyTree()
      L.append(Field('e', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('case_arg.YshExpr')
      L = out_node.fields
      assert self.e is not None
      x0 = self.e.AbbreviatedTree()
      L.append(Field('e', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class pat_e(object):
  Else = 1
  Words = 2
  YshExprs = 3
  Eggex = 4

_pat_str = {
  1: 'pat.Else',
  2: 'pat.Words',
  3: 'pat.YshExprs',
  4: 'pat.Eggex',
}

def pat_str(tag):
  # type: (int) -> str
  return _pat_str[tag]

class pat_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class pat__Else(pat_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('pat__Else')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('pat__Else')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class pat(object):
  Else = pat__Else()
  
  class Words(pat_t):
    _type_tag = 2
    __slots__ = ('words',)
  
    def __init__(self, words):
      # type: (List[word_t]) -> None
      self.words = words
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> pat.Words
      return pat.Words([] if alloc_lists else cast('List[word_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('pat.Words')
      L = out_node.fields
  
      if self.words is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.words:
          x0.children.append(i0.PrettyTree())
        L.append(Field('words', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('pat.Words')
      L = out_node.fields
      if self.words is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.words:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('words', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class YshExprs(pat_t):
    _type_tag = 3
    __slots__ = ('exprs',)
  
    def __init__(self, exprs):
      # type: (List[expr_t]) -> None
      self.exprs = exprs
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> pat.YshExprs
      return pat.YshExprs([] if alloc_lists else cast('List[expr_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('pat.YshExprs')
      L = out_node.fields
  
      if self.exprs is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.exprs:
          x0.children.append(i0.PrettyTree())
        L.append(Field('exprs', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('pat.YshExprs')
      L = out_node.fields
      if self.exprs is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.exprs:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('exprs', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Eggex(pat_t):
    _type_tag = 4
    __slots__ = ('eggex',)
  
    def __init__(self, eggex):
      # type: (re_t) -> None
      self.eggex = eggex
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> pat.Eggex
      return pat.Eggex(cast(re_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('pat.Eggex')
      L = out_node.fields
  
      assert self.eggex is not None
      x0 = self.eggex.PrettyTree()
      L.append(Field('eggex', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('pat.Eggex')
      L = out_node.fields
      assert self.eggex is not None
      x0 = self.eggex.AbbreviatedTree()
      L.append(Field('eggex', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class for_iter_e(object):
  Args = 1
  Words = 2
  YshExpr = 3

_for_iter_str = {
  1: 'for_iter.Args',
  2: 'for_iter.Words',
  3: 'for_iter.YshExpr',
}

def for_iter_str(tag):
  # type: (int) -> str
  return _for_iter_str[tag]

class for_iter_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class for_iter__Args(for_iter_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('for_iter__Args')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('for_iter__Args')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class for_iter(object):
  Args = for_iter__Args()
  
  class Words(for_iter_t):
    _type_tag = 2
    __slots__ = ('words',)
  
    def __init__(self, words):
      # type: (List[word_t]) -> None
      self.words = words
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> for_iter.Words
      return for_iter.Words([] if alloc_lists else cast('List[word_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('for_iter.Words')
      L = out_node.fields
  
      if self.words is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.words:
          x0.children.append(i0.PrettyTree())
        L.append(Field('words', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('for_iter.Words')
      L = out_node.fields
      if self.words is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.words:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('words', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class YshExpr(for_iter_t):
    _type_tag = 3
    __slots__ = ('e', 'blame')
  
    def __init__(self, e, blame):
      # type: (expr_t, Token) -> None
      self.e = e
      self.blame = blame
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> for_iter.YshExpr
      return for_iter.YshExpr(cast(expr_t, None), cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('for_iter.YshExpr')
      L = out_node.fields
  
      assert self.e is not None
      x0 = self.e.PrettyTree()
      L.append(Field('e', x0))
  
      assert self.blame is not None
      x1 = self.blame.PrettyTree()
      L.append(Field('blame', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('for_iter.YshExpr')
      L = out_node.fields
      assert self.e is not None
      x0 = self.e.AbbreviatedTree()
      L.append(Field('e', x0))
  
      assert self.blame is not None
      x1 = self.blame.AbbreviatedTree()
      L.append(Field('blame', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class command_e(object):
  NoOp = 1
  Simple = 2
  ExpandedAlias = 3
  Sentence = 4
  ShAssignment = 5
  Retval = 6
  ControlFlow = 7
  Pipeline = 8
  AndOr = 9
  DoGroup = 10
  BraceGroup = 82
  Subshell = 12
  DParen = 13
  DBracket = 14
  ForEach = 15
  ForExpr = 16
  WhileUntil = 17
  If = 18
  Case = 19
  ShFunction = 20
  TimeBlock = 21
  CommandList = 22
  BareDecl = 23
  VarDecl = 24
  PlaceMutation = 25
  Expr = 26
  Proc = 27
  Func = 28
  TeaFunc = 29
  Data = 30
  Enum = 31
  Class = 32
  Import = 33
  For = 34
  While = 35
  Break = 36
  Continue = 37
  Return = 38

_command_str = {
  1: 'command.NoOp',
  2: 'command.Simple',
  3: 'command.ExpandedAlias',
  4: 'command.Sentence',
  5: 'command.ShAssignment',
  6: 'command.Retval',
  7: 'command.ControlFlow',
  8: 'command.Pipeline',
  9: 'command.AndOr',
  10: 'command.DoGroup',
  12: 'command.Subshell',
  13: 'command.DParen',
  14: 'command.DBracket',
  15: 'command.ForEach',
  16: 'command.ForExpr',
  17: 'command.WhileUntil',
  18: 'command.If',
  19: 'command.Case',
  20: 'command.ShFunction',
  21: 'command.TimeBlock',
  22: 'command.CommandList',
  23: 'command.BareDecl',
  24: 'command.VarDecl',
  25: 'command.PlaceMutation',
  26: 'command.Expr',
  27: 'command.Proc',
  28: 'command.Func',
  29: 'command.TeaFunc',
  30: 'command.Data',
  31: 'command.Enum',
  32: 'command.Class',
  33: 'command.Import',
  34: 'command.For',
  35: 'command.While',
  36: 'command.Break',
  37: 'command.Continue',
  38: 'command.Return',
  82: 'command.BraceGroup',
}

def command_str(tag):
  # type: (int) -> str
  return _command_str[tag]

class command_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class command__NoOp(command_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command__NoOp')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command__NoOp')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Break(command_t):
  _type_tag = 36
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command__Break')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command__Break')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command__Continue(command_t):
  _type_tag = 37
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command__Continue')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('command__Continue')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class command(object):
  NoOp = command__NoOp()
  
  class Simple(command_t):
    _type_tag = 2
    __slots__ = ('blame_tok', 'more_env', 'words', 'redirects', 'typed_args',
                 'block', 'do_fork')
  
    def __init__(self, blame_tok, more_env, words, redirects, typed_args,
                 block, do_fork):
      # type: (Optional[Token], List[EnvPair], List[word_t], List[Redir], Optional[ArgList], Optional[BlockArg], bool) -> None
      self.blame_tok = blame_tok
      self.more_env = more_env
      self.words = words
      self.redirects = redirects
      self.typed_args = typed_args
      self.block = block
      self.do_fork = do_fork
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Simple
      return command.Simple(cast('Optional[Token]', None), [] if alloc_lists
                            else cast('List[EnvPair]', None), [] if alloc_lists
                            else cast('List[word_t]', None), [] if alloc_lists
                            else cast('List[Redir]', None),
                            cast('Optional[ArgList]', None),
                            cast('Optional[BlockArg]', None), False)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Simple')
      L = out_node.fields
  
      if self.blame_tok is not None:  # Optional
        x0 = self.blame_tok.PrettyTree()
        L.append(Field('blame_tok', x0))
  
      if self.more_env is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.more_env:
          x1.children.append(i1.PrettyTree())
        L.append(Field('more_env', x1))
  
      if self.words is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.words:
          x2.children.append(i2.PrettyTree())
        L.append(Field('words', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.PrettyTree())
        L.append(Field('redirects', x3))
  
      if self.typed_args is not None:  # Optional
        x4 = self.typed_args.PrettyTree()
        L.append(Field('typed_args', x4))
  
      if self.block is not None:  # Optional
        x5 = self.block.PrettyTree()
        L.append(Field('block', x5))
  
      x6 = hnode.Leaf('T' if self.do_fork else 'F', color_e.OtherConst)
      L.append(Field('do_fork', x6))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Simple')
      L = out_node.fields
      if self.blame_tok is not None:  # Optional
        x0 = self.blame_tok.AbbreviatedTree()
        L.append(Field('blame_tok', x0))
  
      if self.more_env is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.more_env:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('more_env', x1))
  
      if self.words is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.words:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('words', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.AbbreviatedTree())
        L.append(Field('redirects', x3))
  
      if self.typed_args is not None:  # Optional
        x4 = self.typed_args.AbbreviatedTree()
        L.append(Field('typed_args', x4))
  
      if self.block is not None:  # Optional
        x5 = self.block.AbbreviatedTree()
        L.append(Field('block', x5))
  
      x6 = hnode.Leaf('T' if self.do_fork else 'F', color_e.OtherConst)
      L.append(Field('do_fork', x6))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ExpandedAlias(command_t):
    _type_tag = 3
    __slots__ = ('child', 'redirects', 'more_env')
  
    def __init__(self, child, redirects, more_env):
      # type: (command_t, List[Redir], List[EnvPair]) -> None
      self.child = child
      self.redirects = redirects
      self.more_env = more_env
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.ExpandedAlias
      return command.ExpandedAlias(cast(command_t, None), [] if alloc_lists
                                   else cast('List[Redir]', None), [] if
                                   alloc_lists else cast('List[EnvPair]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ExpandedAlias')
      L = out_node.fields
  
      assert self.child is not None
      x0 = self.child.PrettyTree()
      L.append(Field('child', x0))
  
      if self.redirects is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.redirects:
          x1.children.append(i1.PrettyTree())
        L.append(Field('redirects', x1))
  
      if self.more_env is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.more_env:
          x2.children.append(i2.PrettyTree())
        L.append(Field('more_env', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ExpandedAlias')
      L = out_node.fields
      assert self.child is not None
      x0 = self.child.AbbreviatedTree()
      L.append(Field('child', x0))
  
      if self.redirects is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.redirects:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('redirects', x1))
  
      if self.more_env is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.more_env:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('more_env', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Sentence(command_t):
    _type_tag = 4
    __slots__ = ('child', 'terminator')
  
    def __init__(self, child, terminator):
      # type: (command_t, Token) -> None
      self.child = child
      self.terminator = terminator
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Sentence
      return command.Sentence(cast(command_t, None), cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Sentence')
      L = out_node.fields
  
      assert self.child is not None
      x0 = self.child.PrettyTree()
      L.append(Field('child', x0))
  
      assert self.terminator is not None
      x1 = self.terminator.PrettyTree()
      L.append(Field('terminator', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Sentence')
      L = out_node.fields
      assert self.child is not None
      x0 = self.child.AbbreviatedTree()
      L.append(Field('child', x0))
  
      assert self.terminator is not None
      x1 = self.terminator.AbbreviatedTree()
      L.append(Field('terminator', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ShAssignment(command_t):
    _type_tag = 5
    __slots__ = ('left', 'pairs', 'redirects')
  
    def __init__(self, left, pairs, redirects):
      # type: (Token, List[AssignPair], List[Redir]) -> None
      self.left = left
      self.pairs = pairs
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.ShAssignment
      return command.ShAssignment(cast(Token, None), [] if alloc_lists else
                                  cast('List[AssignPair]', None), [] if
                                  alloc_lists else cast('List[Redir]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ShAssignment')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      if self.pairs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.pairs:
          x1.children.append(i1.PrettyTree())
        L.append(Field('pairs', x1))
  
      if self.redirects is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.redirects:
          x2.children.append(i2.PrettyTree())
        L.append(Field('redirects', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ShAssignment')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      if self.pairs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.pairs:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('pairs', x1))
  
      if self.redirects is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.redirects:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('redirects', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Retval(command_t):
    _type_tag = 6
    __slots__ = ('keyword', 'val')
  
    def __init__(self, keyword, val):
      # type: (Token, expr_t) -> None
      self.keyword = keyword
      self.val = val
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Retval
      return command.Retval(cast(Token, None), cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Retval')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      assert self.val is not None
      x1 = self.val.PrettyTree()
      L.append(Field('val', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Retval')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      assert self.val is not None
      x1 = self.val.AbbreviatedTree()
      L.append(Field('val', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ControlFlow(command_t):
    _type_tag = 7
    __slots__ = ('keyword', 'arg_word')
  
    def __init__(self, keyword, arg_word):
      # type: (Token, Optional[word_t]) -> None
      self.keyword = keyword
      self.arg_word = arg_word
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.ControlFlow
      return command.ControlFlow(cast(Token, None), cast('Optional[word_t]',
                                 None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ControlFlow')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      if self.arg_word is not None:  # Optional
        x1 = self.arg_word.PrettyTree()
        L.append(Field('arg_word', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ControlFlow')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      if self.arg_word is not None:  # Optional
        x1 = self.arg_word.AbbreviatedTree()
        L.append(Field('arg_word', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Pipeline(command_t):
    _type_tag = 8
    __slots__ = ('negated', 'children', 'ops')
  
    def __init__(self, negated, children, ops):
      # type: (Optional[Token], List[command_t], List[Token]) -> None
      self.negated = negated
      self.children = children
      self.ops = ops
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Pipeline
      return command.Pipeline(cast('Optional[Token]', None), [] if alloc_lists
                              else cast('List[command_t]', None), [] if
                              alloc_lists else cast('List[Token]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Pipeline')
      L = out_node.fields
  
      if self.negated is not None:  # Optional
        x0 = self.negated.PrettyTree()
        L.append(Field('negated', x0))
  
      if self.children is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.children:
          x1.children.append(i1.PrettyTree())
        L.append(Field('children', x1))
  
      if self.ops is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.ops:
          x2.children.append(i2.PrettyTree())
        L.append(Field('ops', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Pipeline')
      L = out_node.fields
      if self.negated is not None:  # Optional
        x0 = self.negated.AbbreviatedTree()
        L.append(Field('negated', x0))
  
      if self.children is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.children:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('children', x1))
  
      if self.ops is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.ops:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('ops', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class AndOr(command_t):
    _type_tag = 9
    __slots__ = ('children', 'ops')
  
    def __init__(self, children, ops):
      # type: (List[command_t], List[Token]) -> None
      self.children = children
      self.ops = ops
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.AndOr
      return command.AndOr([] if alloc_lists else cast('List[command_t]',
                           None), [] if alloc_lists else cast('List[Token]',
                           None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.AndOr')
      L = out_node.fields
  
      if self.children is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.children:
          x0.children.append(i0.PrettyTree())
        L.append(Field('children', x0))
  
      if self.ops is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.ops:
          x1.children.append(i1.PrettyTree())
        L.append(Field('ops', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.AndOr')
      L = out_node.fields
      if self.children is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.children:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('children', x0))
  
      if self.ops is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.ops:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('ops', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class DoGroup(command_t):
    _type_tag = 10
    __slots__ = ('left', 'children', 'right')
  
    def __init__(self, left, children, right):
      # type: (Token, List[command_t], Token) -> None
      self.left = left
      self.children = children
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.DoGroup
      return command.DoGroup(cast(Token, None), [] if alloc_lists else
                             cast('List[command_t]', None), cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.DoGroup')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      if self.children is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.children:
          x1.children.append(i1.PrettyTree())
        L.append(Field('children', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.DoGroup')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      if self.children is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.children:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('children', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Subshell(command_t):
    _type_tag = 12
    __slots__ = ('left', 'child', 'right', 'redirects')
  
    def __init__(self, left, child, right, redirects):
      # type: (Token, command_t, Token, List[Redir]) -> None
      self.left = left
      self.child = child
      self.right = right
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Subshell
      return command.Subshell(cast(Token, None), cast(command_t, None),
                              cast(Token, None), [] if alloc_lists else
                              cast('List[Redir]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Subshell')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      assert self.child is not None
      x1 = self.child.PrettyTree()
      L.append(Field('child', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.PrettyTree())
        L.append(Field('redirects', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Subshell')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      assert self.child is not None
      x1 = self.child.AbbreviatedTree()
      L.append(Field('child', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.AbbreviatedTree())
        L.append(Field('redirects', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class DParen(command_t):
    _type_tag = 13
    __slots__ = ('left', 'child', 'right', 'redirects')
  
    def __init__(self, left, child, right, redirects):
      # type: (Token, arith_expr_t, Token, List[Redir]) -> None
      self.left = left
      self.child = child
      self.right = right
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.DParen
      return command.DParen(cast(Token, None), cast(arith_expr_t, None),
                            cast(Token, None), [] if alloc_lists else
                            cast('List[Redir]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.DParen')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      assert self.child is not None
      x1 = self.child.PrettyTree()
      L.append(Field('child', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.PrettyTree())
        L.append(Field('redirects', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.DParen')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      assert self.child is not None
      x1 = self.child.AbbreviatedTree()
      L.append(Field('child', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.AbbreviatedTree())
        L.append(Field('redirects', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class DBracket(command_t):
    _type_tag = 14
    __slots__ = ('left', 'expr', 'right', 'redirects')
  
    def __init__(self, left, expr, right, redirects):
      # type: (Token, bool_expr_t, Token, List[Redir]) -> None
      self.left = left
      self.expr = expr
      self.right = right
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.DBracket
      return command.DBracket(cast(Token, None), cast(bool_expr_t, None),
                              cast(Token, None), [] if alloc_lists else
                              cast('List[Redir]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.DBracket')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      assert self.expr is not None
      x1 = self.expr.PrettyTree()
      L.append(Field('expr', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.PrettyTree())
        L.append(Field('redirects', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.DBracket')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      assert self.expr is not None
      x1 = self.expr.AbbreviatedTree()
      L.append(Field('expr', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.AbbreviatedTree())
        L.append(Field('redirects', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ForEach(command_t):
    _type_tag = 15
    __slots__ = ('keyword', 'iter_names', 'iterable', 'semi_tok', 'body',
                 'redirects')
  
    def __init__(self, keyword, iter_names, iterable, semi_tok, body,
                 redirects):
      # type: (Token, List[str], for_iter_t, Optional[Token], command_t, List[Redir]) -> None
      self.keyword = keyword
      self.iter_names = iter_names
      self.iterable = iterable
      self.semi_tok = semi_tok
      self.body = body
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.ForEach
      return command.ForEach(cast(Token, None), [] if alloc_lists else
                             cast('List[str]', None), cast(for_iter_t, None),
                             cast('Optional[Token]', None), cast(command_t,
                             None), [] if alloc_lists else cast('List[Redir]',
                             None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ForEach')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      if self.iter_names is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.iter_names:
          x1.children.append(NewLeaf(i1, color_e.StringConst))
        L.append(Field('iter_names', x1))
  
      assert self.iterable is not None
      x2 = self.iterable.PrettyTree()
      L.append(Field('iterable', x2))
  
      if self.semi_tok is not None:  # Optional
        x3 = self.semi_tok.PrettyTree()
        L.append(Field('semi_tok', x3))
  
      assert self.body is not None
      x4 = self.body.PrettyTree()
      L.append(Field('body', x4))
  
      if self.redirects is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.redirects:
          x5.children.append(i5.PrettyTree())
        L.append(Field('redirects', x5))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ForEach')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      if self.iter_names is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.iter_names:
          x1.children.append(NewLeaf(i1, color_e.StringConst))
        L.append(Field('iter_names', x1))
  
      assert self.iterable is not None
      x2 = self.iterable.AbbreviatedTree()
      L.append(Field('iterable', x2))
  
      if self.semi_tok is not None:  # Optional
        x3 = self.semi_tok.AbbreviatedTree()
        L.append(Field('semi_tok', x3))
  
      assert self.body is not None
      x4 = self.body.AbbreviatedTree()
      L.append(Field('body', x4))
  
      if self.redirects is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.redirects:
          x5.children.append(i5.AbbreviatedTree())
        L.append(Field('redirects', x5))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ForExpr(command_t):
    _type_tag = 16
    __slots__ = ('keyword', 'init', 'cond', 'update', 'body', 'redirects')
  
    def __init__(self, keyword, init, cond, update, body, redirects):
      # type: (Token, Optional[arith_expr_t], Optional[arith_expr_t], Optional[arith_expr_t], Optional[command_t], List[Redir]) -> None
      self.keyword = keyword
      self.init = init
      self.cond = cond
      self.update = update
      self.body = body
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.ForExpr
      return command.ForExpr(cast(Token, None), cast('Optional[arith_expr_t]',
                             None), cast('Optional[arith_expr_t]', None),
                             cast('Optional[arith_expr_t]', None),
                             cast('Optional[command_t]', None), [] if
                             alloc_lists else cast('List[Redir]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ForExpr')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      if self.init is not None:  # Optional
        x1 = self.init.PrettyTree()
        L.append(Field('init', x1))
  
      if self.cond is not None:  # Optional
        x2 = self.cond.PrettyTree()
        L.append(Field('cond', x2))
  
      if self.update is not None:  # Optional
        x3 = self.update.PrettyTree()
        L.append(Field('update', x3))
  
      if self.body is not None:  # Optional
        x4 = self.body.PrettyTree()
        L.append(Field('body', x4))
  
      if self.redirects is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.redirects:
          x5.children.append(i5.PrettyTree())
        L.append(Field('redirects', x5))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ForExpr')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      if self.init is not None:  # Optional
        x1 = self.init.AbbreviatedTree()
        L.append(Field('init', x1))
  
      if self.cond is not None:  # Optional
        x2 = self.cond.AbbreviatedTree()
        L.append(Field('cond', x2))
  
      if self.update is not None:  # Optional
        x3 = self.update.AbbreviatedTree()
        L.append(Field('update', x3))
  
      if self.body is not None:  # Optional
        x4 = self.body.AbbreviatedTree()
        L.append(Field('body', x4))
  
      if self.redirects is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.redirects:
          x5.children.append(i5.AbbreviatedTree())
        L.append(Field('redirects', x5))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class WhileUntil(command_t):
    _type_tag = 17
    __slots__ = ('keyword', 'cond', 'body', 'redirects')
  
    def __init__(self, keyword, cond, body, redirects):
      # type: (Token, condition_t, command_t, List[Redir]) -> None
      self.keyword = keyword
      self.cond = cond
      self.body = body
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.WhileUntil
      return command.WhileUntil(cast(Token, None), cast(condition_t, None),
                                cast(command_t, None), [] if alloc_lists else
                                cast('List[Redir]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.WhileUntil')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      assert self.cond is not None
      x1 = self.cond.PrettyTree()
      L.append(Field('cond', x1))
  
      assert self.body is not None
      x2 = self.body.PrettyTree()
      L.append(Field('body', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.PrettyTree())
        L.append(Field('redirects', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.WhileUntil')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      assert self.cond is not None
      x1 = self.cond.AbbreviatedTree()
      L.append(Field('cond', x1))
  
      assert self.body is not None
      x2 = self.body.AbbreviatedTree()
      L.append(Field('body', x2))
  
      if self.redirects is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.redirects:
          x3.children.append(i3.AbbreviatedTree())
        L.append(Field('redirects', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class If(command_t):
    _type_tag = 18
    __slots__ = ('if_kw', 'arms', 'else_kw', 'else_action', 'fi_kw',
                 'redirects')
  
    def __init__(self, if_kw, arms, else_kw, else_action, fi_kw, redirects):
      # type: (Token, List[IfArm], Optional[Token], List[command_t], Optional[Token], List[Redir]) -> None
      self.if_kw = if_kw
      self.arms = arms
      self.else_kw = else_kw
      self.else_action = else_action
      self.fi_kw = fi_kw
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.If
      return command.If(cast(Token, None), [] if alloc_lists else
                        cast('List[IfArm]', None), cast('Optional[Token]',
                        None), [] if alloc_lists else cast('List[command_t]',
                        None), cast('Optional[Token]', None), [] if alloc_lists
                        else cast('List[Redir]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.If')
      L = out_node.fields
  
      assert self.if_kw is not None
      x0 = self.if_kw.PrettyTree()
      L.append(Field('if_kw', x0))
  
      if self.arms is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.arms:
          x1.children.append(i1.PrettyTree())
        L.append(Field('arms', x1))
  
      if self.else_kw is not None:  # Optional
        x2 = self.else_kw.PrettyTree()
        L.append(Field('else_kw', x2))
  
      if self.else_action is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.else_action:
          x3.children.append(i3.PrettyTree())
        L.append(Field('else_action', x3))
  
      if self.fi_kw is not None:  # Optional
        x4 = self.fi_kw.PrettyTree()
        L.append(Field('fi_kw', x4))
  
      if self.redirects is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.redirects:
          x5.children.append(i5.PrettyTree())
        L.append(Field('redirects', x5))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.If')
      L = out_node.fields
      assert self.if_kw is not None
      x0 = self.if_kw.AbbreviatedTree()
      L.append(Field('if_kw', x0))
  
      if self.arms is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.arms:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('arms', x1))
  
      if self.else_kw is not None:  # Optional
        x2 = self.else_kw.AbbreviatedTree()
        L.append(Field('else_kw', x2))
  
      if self.else_action is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.else_action:
          x3.children.append(i3.AbbreviatedTree())
        L.append(Field('else_action', x3))
  
      if self.fi_kw is not None:  # Optional
        x4 = self.fi_kw.AbbreviatedTree()
        L.append(Field('fi_kw', x4))
  
      if self.redirects is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.redirects:
          x5.children.append(i5.AbbreviatedTree())
        L.append(Field('redirects', x5))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Case(command_t):
    _type_tag = 19
    __slots__ = ('case_kw', 'to_match', 'arms_start', 'arms', 'arms_end',
                 'redirects')
  
    def __init__(self, case_kw, to_match, arms_start, arms, arms_end,
                 redirects):
      # type: (Token, case_arg_t, Token, List[CaseArm], Token, List[Redir]) -> None
      self.case_kw = case_kw
      self.to_match = to_match
      self.arms_start = arms_start
      self.arms = arms
      self.arms_end = arms_end
      self.redirects = redirects
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Case
      return command.Case(cast(Token, None), cast(case_arg_t, None),
                          cast(Token, None), [] if alloc_lists else
                          cast('List[CaseArm]', None), cast(Token, None), [] if
                          alloc_lists else cast('List[Redir]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Case')
      L = out_node.fields
  
      assert self.case_kw is not None
      x0 = self.case_kw.PrettyTree()
      L.append(Field('case_kw', x0))
  
      assert self.to_match is not None
      x1 = self.to_match.PrettyTree()
      L.append(Field('to_match', x1))
  
      assert self.arms_start is not None
      x2 = self.arms_start.PrettyTree()
      L.append(Field('arms_start', x2))
  
      if self.arms is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.arms:
          x3.children.append(i3.PrettyTree())
        L.append(Field('arms', x3))
  
      assert self.arms_end is not None
      x4 = self.arms_end.PrettyTree()
      L.append(Field('arms_end', x4))
  
      if self.redirects is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.redirects:
          x5.children.append(i5.PrettyTree())
        L.append(Field('redirects', x5))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Case')
      L = out_node.fields
      assert self.case_kw is not None
      x0 = self.case_kw.AbbreviatedTree()
      L.append(Field('case_kw', x0))
  
      assert self.to_match is not None
      x1 = self.to_match.AbbreviatedTree()
      L.append(Field('to_match', x1))
  
      assert self.arms_start is not None
      x2 = self.arms_start.AbbreviatedTree()
      L.append(Field('arms_start', x2))
  
      if self.arms is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.arms:
          x3.children.append(i3.AbbreviatedTree())
        L.append(Field('arms', x3))
  
      assert self.arms_end is not None
      x4 = self.arms_end.AbbreviatedTree()
      L.append(Field('arms_end', x4))
  
      if self.redirects is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.redirects:
          x5.children.append(i5.AbbreviatedTree())
        L.append(Field('redirects', x5))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class ShFunction(command_t):
    _type_tag = 20
    __slots__ = ('keyword', 'name_tok', 'name', 'body')
  
    def __init__(self, keyword, name_tok, name, body):
      # type: (Optional[Token], Token, str, command_t) -> None
      self.keyword = keyword
      self.name_tok = name_tok
      self.name = name
      self.body = body
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.ShFunction
      return command.ShFunction(cast('Optional[Token]', None), cast(Token,
                                None), '', cast(command_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ShFunction')
      L = out_node.fields
  
      if self.keyword is not None:  # Optional
        x0 = self.keyword.PrettyTree()
        L.append(Field('keyword', x0))
  
      assert self.name_tok is not None
      x1 = self.name_tok.PrettyTree()
      L.append(Field('name_tok', x1))
  
      x2 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x2))
  
      assert self.body is not None
      x3 = self.body.PrettyTree()
      L.append(Field('body', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.ShFunction')
      L = out_node.fields
      if self.keyword is not None:  # Optional
        x0 = self.keyword.AbbreviatedTree()
        L.append(Field('keyword', x0))
  
      assert self.name_tok is not None
      x1 = self.name_tok.AbbreviatedTree()
      L.append(Field('name_tok', x1))
  
      x2 = NewLeaf(self.name, color_e.StringConst)
      L.append(Field('name', x2))
  
      assert self.body is not None
      x3 = self.body.AbbreviatedTree()
      L.append(Field('body', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class TimeBlock(command_t):
    _type_tag = 21
    __slots__ = ('keyword', 'pipeline')
  
    def __init__(self, keyword, pipeline):
      # type: (Token, command_t) -> None
      self.keyword = keyword
      self.pipeline = pipeline
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.TimeBlock
      return command.TimeBlock(cast(Token, None), cast(command_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.TimeBlock')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      assert self.pipeline is not None
      x1 = self.pipeline.PrettyTree()
      L.append(Field('pipeline', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.TimeBlock')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      assert self.pipeline is not None
      x1 = self.pipeline.AbbreviatedTree()
      L.append(Field('pipeline', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class CommandList(command_t):
    _type_tag = 22
    __slots__ = ('children',)
  
    def __init__(self, children):
      # type: (List[command_t]) -> None
      self.children = children
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.CommandList
      return command.CommandList([] if alloc_lists else cast('List[command_t]',
                                 None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.CommandList')
      L = out_node.fields
  
      if self.children is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.children:
          x0.children.append(i0.PrettyTree())
        L.append(Field('children', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.CommandList')
      L = out_node.fields
      if self.children is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.children:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('children', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class BareDecl(command_t):
    _type_tag = 23
    __slots__ = ('lhs', 'rhs')
  
    def __init__(self, lhs, rhs):
      # type: (Token, expr_t) -> None
      self.lhs = lhs
      self.rhs = rhs
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.BareDecl
      return command.BareDecl(cast(Token, None), cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.BareDecl')
      L = out_node.fields
  
      assert self.lhs is not None
      x0 = self.lhs.PrettyTree()
      L.append(Field('lhs', x0))
  
      assert self.rhs is not None
      x1 = self.rhs.PrettyTree()
      L.append(Field('rhs', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.BareDecl')
      L = out_node.fields
      assert self.lhs is not None
      x0 = self.lhs.AbbreviatedTree()
      L.append(Field('lhs', x0))
  
      assert self.rhs is not None
      x1 = self.rhs.AbbreviatedTree()
      L.append(Field('rhs', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class VarDecl(command_t):
    _type_tag = 24
    __slots__ = ('keyword', 'lhs', 'rhs')
  
    def __init__(self, keyword, lhs, rhs):
      # type: (Optional[Token], List[NameType], expr_t) -> None
      self.keyword = keyword
      self.lhs = lhs
      self.rhs = rhs
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.VarDecl
      return command.VarDecl(cast('Optional[Token]', None), [] if alloc_lists
                             else cast('List[NameType]', None), cast(expr_t,
                             None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.VarDecl')
      L = out_node.fields
  
      if self.keyword is not None:  # Optional
        x0 = self.keyword.PrettyTree()
        L.append(Field('keyword', x0))
  
      if self.lhs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.lhs:
          x1.children.append(i1.PrettyTree())
        L.append(Field('lhs', x1))
  
      assert self.rhs is not None
      x2 = self.rhs.PrettyTree()
      L.append(Field('rhs', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.VarDecl')
      L = out_node.fields
      if self.keyword is not None:  # Optional
        x0 = self.keyword.AbbreviatedTree()
        L.append(Field('keyword', x0))
  
      if self.lhs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.lhs:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('lhs', x1))
  
      assert self.rhs is not None
      x2 = self.rhs.AbbreviatedTree()
      L.append(Field('rhs', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class PlaceMutation(command_t):
    _type_tag = 25
    __slots__ = ('keyword', 'lhs', 'op', 'rhs')
  
    def __init__(self, keyword, lhs, op, rhs):
      # type: (Token, List[place_expr_t], Token, expr_t) -> None
      self.keyword = keyword
      self.lhs = lhs
      self.op = op
      self.rhs = rhs
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.PlaceMutation
      return command.PlaceMutation(cast(Token, None), [] if alloc_lists else
                                   cast('List[place_expr_t]', None),
                                   cast(Token, None), cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.PlaceMutation')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      if self.lhs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.lhs:
          x1.children.append(i1.PrettyTree())
        L.append(Field('lhs', x1))
  
      assert self.op is not None
      x2 = self.op.PrettyTree()
      L.append(Field('op', x2))
  
      assert self.rhs is not None
      x3 = self.rhs.PrettyTree()
      L.append(Field('rhs', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.PlaceMutation')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      if self.lhs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.lhs:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('lhs', x1))
  
      assert self.op is not None
      x2 = self.op.AbbreviatedTree()
      L.append(Field('op', x2))
  
      assert self.rhs is not None
      x3 = self.rhs.AbbreviatedTree()
      L.append(Field('rhs', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Expr(command_t):
    _type_tag = 26
    __slots__ = ('keyword', 'e')
  
    def __init__(self, keyword, e):
      # type: (Token, expr_t) -> None
      self.keyword = keyword
      self.e = e
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Expr
      return command.Expr(cast(Token, None), cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Expr')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      assert self.e is not None
      x1 = self.e.PrettyTree()
      L.append(Field('e', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Expr')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      assert self.e is not None
      x1 = self.e.AbbreviatedTree()
      L.append(Field('e', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Proc(command_t):
    _type_tag = 27
    __slots__ = ('keyword', 'name', 'sig', 'body')
  
    def __init__(self, keyword, name, sig, body):
      # type: (Token, Token, proc_sig_t, command_t) -> None
      self.keyword = keyword
      self.name = name
      self.sig = sig
      self.body = body
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Proc
      return command.Proc(cast(Token, None), cast(Token, None),
                          cast(proc_sig_t, None), cast(command_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Proc')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      assert self.name is not None
      x1 = self.name.PrettyTree()
      L.append(Field('name', x1))
  
      assert self.sig is not None
      x2 = self.sig.PrettyTree()
      L.append(Field('sig', x2))
  
      assert self.body is not None
      x3 = self.body.PrettyTree()
      L.append(Field('body', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Proc')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      assert self.name is not None
      x1 = self.name.AbbreviatedTree()
      L.append(Field('name', x1))
  
      assert self.sig is not None
      x2 = self.sig.AbbreviatedTree()
      L.append(Field('sig', x2))
  
      assert self.body is not None
      x3 = self.body.AbbreviatedTree()
      L.append(Field('body', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Func(command_t):
    _type_tag = 28
    __slots__ = ('keyword', 'name', 'pos_params', 'rest_of_pos',
                 'named_params', 'rest_of_named', 'body')
  
    def __init__(self, keyword, name, pos_params, rest_of_pos, named_params,
                 rest_of_named, body):
      # type: (Token, Token, List[Param], Optional[RestParam], List[Param], Optional[RestParam], command_t) -> None
      self.keyword = keyword
      self.name = name
      self.pos_params = pos_params
      self.rest_of_pos = rest_of_pos
      self.named_params = named_params
      self.rest_of_named = rest_of_named
      self.body = body
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Func
      return command.Func(cast(Token, None), cast(Token, None), [] if
                          alloc_lists else cast('List[Param]', None),
                          cast('Optional[RestParam]', None), [] if alloc_lists
                          else cast('List[Param]', None),
                          cast('Optional[RestParam]', None), cast(command_t,
                          None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Func')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      assert self.name is not None
      x1 = self.name.PrettyTree()
      L.append(Field('name', x1))
  
      if self.pos_params is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.pos_params:
          x2.children.append(i2.PrettyTree())
        L.append(Field('pos_params', x2))
  
      if self.rest_of_pos is not None:  # Optional
        x3 = self.rest_of_pos.PrettyTree()
        L.append(Field('rest_of_pos', x3))
  
      if self.named_params is not None:  # List
        x4 = hnode.Array([])
        for i4 in self.named_params:
          x4.children.append(i4.PrettyTree())
        L.append(Field('named_params', x4))
  
      if self.rest_of_named is not None:  # Optional
        x5 = self.rest_of_named.PrettyTree()
        L.append(Field('rest_of_named', x5))
  
      assert self.body is not None
      x6 = self.body.PrettyTree()
      L.append(Field('body', x6))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Func')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      assert self.name is not None
      x1 = self.name.AbbreviatedTree()
      L.append(Field('name', x1))
  
      if self.pos_params is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.pos_params:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('pos_params', x2))
  
      if self.rest_of_pos is not None:  # Optional
        x3 = self.rest_of_pos.AbbreviatedTree()
        L.append(Field('rest_of_pos', x3))
  
      if self.named_params is not None:  # List
        x4 = hnode.Array([])
        for i4 in self.named_params:
          x4.children.append(i4.AbbreviatedTree())
        L.append(Field('named_params', x4))
  
      if self.rest_of_named is not None:  # Optional
        x5 = self.rest_of_named.AbbreviatedTree()
        L.append(Field('rest_of_named', x5))
  
      assert self.body is not None
      x6 = self.body.AbbreviatedTree()
      L.append(Field('body', x6))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class TeaFunc(command_t):
    _type_tag = 29
    __slots__ = ('name', 'pos_params', 'pos_splat', 'named_params',
                 'named_splat', 'return_types', 'body')
  
    def __init__(self, name, pos_params, pos_splat, named_params, named_splat,
                 return_types, body):
      # type: (Token, List[Param], Optional[RestParam], List[Param], Optional[RestParam], List[TypeExpr], command_t) -> None
      self.name = name
      self.pos_params = pos_params
      self.pos_splat = pos_splat
      self.named_params = named_params
      self.named_splat = named_splat
      self.return_types = return_types
      self.body = body
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.TeaFunc
      return command.TeaFunc(cast(Token, None), [] if alloc_lists else
                             cast('List[Param]', None),
                             cast('Optional[RestParam]', None), [] if
                             alloc_lists else cast('List[Param]', None),
                             cast('Optional[RestParam]', None), [] if
                             alloc_lists else cast('List[TypeExpr]', None),
                             cast(command_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.TeaFunc')
      L = out_node.fields
  
      assert self.name is not None
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))
  
      if self.pos_params is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.pos_params:
          x1.children.append(i1.PrettyTree())
        L.append(Field('pos_params', x1))
  
      if self.pos_splat is not None:  # Optional
        x2 = self.pos_splat.PrettyTree()
        L.append(Field('pos_splat', x2))
  
      if self.named_params is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.named_params:
          x3.children.append(i3.PrettyTree())
        L.append(Field('named_params', x3))
  
      if self.named_splat is not None:  # Optional
        x4 = self.named_splat.PrettyTree()
        L.append(Field('named_splat', x4))
  
      if self.return_types is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.return_types:
          x5.children.append(i5.PrettyTree())
        L.append(Field('return_types', x5))
  
      assert self.body is not None
      x6 = self.body.PrettyTree()
      L.append(Field('body', x6))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.TeaFunc')
      L = out_node.fields
      assert self.name is not None
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))
  
      if self.pos_params is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.pos_params:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('pos_params', x1))
  
      if self.pos_splat is not None:  # Optional
        x2 = self.pos_splat.AbbreviatedTree()
        L.append(Field('pos_splat', x2))
  
      if self.named_params is not None:  # List
        x3 = hnode.Array([])
        for i3 in self.named_params:
          x3.children.append(i3.AbbreviatedTree())
        L.append(Field('named_params', x3))
  
      if self.named_splat is not None:  # Optional
        x4 = self.named_splat.AbbreviatedTree()
        L.append(Field('named_splat', x4))
  
      if self.return_types is not None:  # List
        x5 = hnode.Array([])
        for i5 in self.return_types:
          x5.children.append(i5.AbbreviatedTree())
        L.append(Field('return_types', x5))
  
      assert self.body is not None
      x6 = self.body.AbbreviatedTree()
      L.append(Field('body', x6))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Data(command_t):
    _type_tag = 30
    __slots__ = ('name', 'params')
  
    def __init__(self, name, params):
      # type: (Token, List[Param]) -> None
      self.name = name
      self.params = params
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Data
      return command.Data(cast(Token, None), [] if alloc_lists else
                          cast('List[Param]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Data')
      L = out_node.fields
  
      assert self.name is not None
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))
  
      if self.params is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.params:
          x1.children.append(i1.PrettyTree())
        L.append(Field('params', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Data')
      L = out_node.fields
      assert self.name is not None
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))
  
      if self.params is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.params:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('params', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Enum(command_t):
    _type_tag = 31
    __slots__ = ('name', 'variants')
  
    def __init__(self, name, variants):
      # type: (Token, List[Variant]) -> None
      self.name = name
      self.variants = variants
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Enum
      return command.Enum(cast(Token, None), [] if alloc_lists else
                          cast('List[Variant]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Enum')
      L = out_node.fields
  
      assert self.name is not None
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))
  
      if self.variants is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.variants:
          x1.children.append(i1.PrettyTree())
        L.append(Field('variants', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Enum')
      L = out_node.fields
      assert self.name is not None
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))
  
      if self.variants is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.variants:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('variants', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Class(command_t):
    _type_tag = 32
    __slots__ = ('name', 'extends', 'items')
  
    def __init__(self, name, extends, items):
      # type: (Token, Optional[Token], List[class_item_t]) -> None
      self.name = name
      self.extends = extends
      self.items = items
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Class
      return command.Class(cast(Token, None), cast('Optional[Token]', None), []
                           if alloc_lists else cast('List[class_item_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Class')
      L = out_node.fields
  
      assert self.name is not None
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))
  
      if self.extends is not None:  # Optional
        x1 = self.extends.PrettyTree()
        L.append(Field('extends', x1))
  
      if self.items is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.items:
          x2.children.append(i2.PrettyTree())
        L.append(Field('items', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Class')
      L = out_node.fields
      assert self.name is not None
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))
  
      if self.extends is not None:  # Optional
        x1 = self.extends.AbbreviatedTree()
        L.append(Field('extends', x1))
  
      if self.items is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.items:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('items', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Import(command_t):
    _type_tag = 33
    __slots__ = ('path', 'alias', 'names')
  
    def __init__(self, path, alias, names):
      # type: (SingleQuoted, Optional[Token], List[ImportName]) -> None
      self.path = path
      self.alias = alias
      self.names = names
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Import
      return command.Import(cast(SingleQuoted, None), cast('Optional[Token]',
                            None), [] if alloc_lists else
                            cast('List[ImportName]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Import')
      L = out_node.fields
  
      assert self.path is not None
      x0 = self.path.PrettyTree()
      L.append(Field('path', x0))
  
      if self.alias is not None:  # Optional
        x1 = self.alias.PrettyTree()
        L.append(Field('alias', x1))
  
      if self.names is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.names:
          x2.children.append(i2.PrettyTree())
        L.append(Field('names', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Import')
      L = out_node.fields
      assert self.path is not None
      x0 = self.path.AbbreviatedTree()
      L.append(Field('path', x0))
  
      if self.alias is not None:  # Optional
        x1 = self.alias.AbbreviatedTree()
        L.append(Field('alias', x1))
  
      if self.names is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.names:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('names', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class For(command_t):
    _type_tag = 34
    __slots__ = ('targets', 'iterable', 'body')
  
    def __init__(self, targets, iterable, body):
      # type: (List[NameType], expr_t, command_t) -> None
      self.targets = targets
      self.iterable = iterable
      self.body = body
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.For
      return command.For([] if alloc_lists else cast('List[NameType]', None),
                         cast(expr_t, None), cast(command_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.For')
      L = out_node.fields
  
      if self.targets is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.targets:
          x0.children.append(i0.PrettyTree())
        L.append(Field('targets', x0))
  
      assert self.iterable is not None
      x1 = self.iterable.PrettyTree()
      L.append(Field('iterable', x1))
  
      assert self.body is not None
      x2 = self.body.PrettyTree()
      L.append(Field('body', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.For')
      L = out_node.fields
      if self.targets is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.targets:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('targets', x0))
  
      assert self.iterable is not None
      x1 = self.iterable.AbbreviatedTree()
      L.append(Field('iterable', x1))
  
      assert self.body is not None
      x2 = self.body.AbbreviatedTree()
      L.append(Field('body', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class While(command_t):
    _type_tag = 35
    __slots__ = ('test', 'body')
  
    def __init__(self, test, body):
      # type: (expr_t, command_t) -> None
      self.test = test
      self.body = body
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.While
      return command.While(cast(expr_t, None), cast(command_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.While')
      L = out_node.fields
  
      assert self.test is not None
      x0 = self.test.PrettyTree()
      L.append(Field('test', x0))
  
      assert self.body is not None
      x1 = self.body.PrettyTree()
      L.append(Field('body', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.While')
      L = out_node.fields
      assert self.test is not None
      x0 = self.test.AbbreviatedTree()
      L.append(Field('test', x0))
  
      assert self.body is not None
      x1 = self.body.AbbreviatedTree()
      L.append(Field('body', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  Break = command__Break()
  
  Continue = command__Continue()
  
  class Return(command_t):
    _type_tag = 38
    __slots__ = ('value',)
  
    def __init__(self, value):
      # type: (Optional[expr_t]) -> None
      self.value = value
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> command.Return
      return command.Return(cast('Optional[expr_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Return')
      L = out_node.fields
  
      if self.value is not None:  # Optional
        x0 = self.value.PrettyTree()
        L.append(Field('value', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('command.Return')
      L = out_node.fields
      if self.value is not None:  # Optional
        x0 = self.value.AbbreviatedTree()
        L.append(Field('value', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class variant_type_e(object):
  Anon = 1
  Ref = 2

_variant_type_str = {
  1: 'variant_type.Anon',
  2: 'variant_type.Ref',
}

def variant_type_str(tag):
  # type: (int) -> str
  return _variant_type_str[tag]

class variant_type_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class variant_type(object):
  class Anon(variant_type_t):
    _type_tag = 1
    __slots__ = ('params',)
  
    def __init__(self, params):
      # type: (List[Param]) -> None
      self.params = params
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> variant_type.Anon
      return variant_type.Anon([] if alloc_lists else cast('List[Param]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('variant_type.Anon')
      L = out_node.fields
  
      if self.params is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.params:
          x0.children.append(i0.PrettyTree())
        L.append(Field('params', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('variant_type.Anon')
      L = out_node.fields
      if self.params is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.params:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('params', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Ref(variant_type_t):
    _type_tag = 2
    __slots__ = ('type_name',)
  
    def __init__(self, type_name):
      # type: (Token) -> None
      self.type_name = type_name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> variant_type.Ref
      return variant_type.Ref(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('variant_type.Ref')
      L = out_node.fields
  
      assert self.type_name is not None
      x0 = self.type_name.PrettyTree()
      L.append(Field('type_name', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('variant_type.Ref')
      L = out_node.fields
      assert self.type_name is not None
      x0 = self.type_name.AbbreviatedTree()
      L.append(Field('type_name', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class class_item_e(object):
  Data = 1
  Method = 2

_class_item_str = {
  1: 'class_item.Data',
  2: 'class_item.Method',
}

def class_item_str(tag):
  # type: (int) -> str
  return _class_item_str[tag]

class class_item_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class class_item__Method(class_item_t):
  _type_tag = 2
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_item__Method')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('class_item__Method')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class class_item(object):
  class Data(class_item_t):
    _type_tag = 1
    __slots__ = ('keyword', 'fields')
  
    def __init__(self, keyword, fields):
      # type: (Token, List[NameType]) -> None
      self.keyword = keyword
      self.fields = fields
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> class_item.Data
      return class_item.Data(cast(Token, None), [] if alloc_lists else
                             cast('List[NameType]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('class_item.Data')
      L = out_node.fields
  
      assert self.keyword is not None
      x0 = self.keyword.PrettyTree()
      L.append(Field('keyword', x0))
  
      if self.fields is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.fields:
          x1.children.append(i1.PrettyTree())
        L.append(Field('fields', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('class_item.Data')
      L = out_node.fields
      assert self.keyword is not None
      x0 = self.keyword.AbbreviatedTree()
      L.append(Field('keyword', x0))
  
      if self.fields is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.fields:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('fields', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  Method = class_item__Method()
  

class proc_sig_e(object):
  Open = 1
  Closed = 2

_proc_sig_str = {
  1: 'proc_sig.Open',
  2: 'proc_sig.Closed',
}

def proc_sig_str(tag):
  # type: (int) -> str
  return _proc_sig_str[tag]

class proc_sig_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class proc_sig__Open(proc_sig_t):
  _type_tag = 1
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('proc_sig__Open')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('proc_sig__Open')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class proc_sig(object):
  Open = proc_sig__Open()
  
  class Closed(proc_sig_t):
    _type_tag = 2
    __slots__ = ('word_params', 'rest_of_words', 'pos_params', 'rest_of_pos',
                 'named_params', 'rest_of_named', 'block_param')
  
    def __init__(self, word_params, rest_of_words, pos_params, rest_of_pos,
                 named_params, rest_of_named, block_param):
      # type: (List[Param], Optional[RestParam], List[Param], Optional[RestParam], List[Param], Optional[RestParam], Optional[RestParam]) -> None
      self.word_params = word_params
      self.rest_of_words = rest_of_words
      self.pos_params = pos_params
      self.rest_of_pos = rest_of_pos
      self.named_params = named_params
      self.rest_of_named = rest_of_named
      self.block_param = block_param
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> proc_sig.Closed
      return proc_sig.Closed([] if alloc_lists else cast('List[Param]', None),
                             cast('Optional[RestParam]', None), [] if
                             alloc_lists else cast('List[Param]', None),
                             cast('Optional[RestParam]', None), [] if
                             alloc_lists else cast('List[Param]', None),
                             cast('Optional[RestParam]', None),
                             cast('Optional[RestParam]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('proc_sig.Closed')
      L = out_node.fields
  
      if self.word_params is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.word_params:
          x0.children.append(i0.PrettyTree())
        L.append(Field('word_params', x0))
  
      if self.rest_of_words is not None:  # Optional
        x1 = self.rest_of_words.PrettyTree()
        L.append(Field('rest_of_words', x1))
  
      if self.pos_params is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.pos_params:
          x2.children.append(i2.PrettyTree())
        L.append(Field('pos_params', x2))
  
      if self.rest_of_pos is not None:  # Optional
        x3 = self.rest_of_pos.PrettyTree()
        L.append(Field('rest_of_pos', x3))
  
      if self.named_params is not None:  # List
        x4 = hnode.Array([])
        for i4 in self.named_params:
          x4.children.append(i4.PrettyTree())
        L.append(Field('named_params', x4))
  
      if self.rest_of_named is not None:  # Optional
        x5 = self.rest_of_named.PrettyTree()
        L.append(Field('rest_of_named', x5))
  
      if self.block_param is not None:  # Optional
        x6 = self.block_param.PrettyTree()
        L.append(Field('block_param', x6))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('proc_sig.Closed')
      L = out_node.fields
      if self.word_params is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.word_params:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('word_params', x0))
  
      if self.rest_of_words is not None:  # Optional
        x1 = self.rest_of_words.AbbreviatedTree()
        L.append(Field('rest_of_words', x1))
  
      if self.pos_params is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.pos_params:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('pos_params', x2))
  
      if self.rest_of_pos is not None:  # Optional
        x3 = self.rest_of_pos.AbbreviatedTree()
        L.append(Field('rest_of_pos', x3))
  
      if self.named_params is not None:  # List
        x4 = hnode.Array([])
        for i4 in self.named_params:
          x4.children.append(i4.AbbreviatedTree())
        L.append(Field('named_params', x4))
  
      if self.rest_of_named is not None:  # Optional
        x5 = self.rest_of_named.AbbreviatedTree()
        L.append(Field('rest_of_named', x5))
  
      if self.block_param is not None:  # Optional
        x6 = self.block_param.AbbreviatedTree()
        L.append(Field('block_param', x6))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class glob_part_e(object):
  Literal = 1
  Operator = 2
  CharClass = 3

_glob_part_str = {
  1: 'glob_part.Literal',
  2: 'glob_part.Operator',
  3: 'glob_part.CharClass',
}

def glob_part_str(tag):
  # type: (int) -> str
  return _glob_part_str[tag]

class glob_part_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class glob_part(object):
  class Literal(glob_part_t):
    _type_tag = 1
    __slots__ = ('id', 's')
  
    def __init__(self, id, s):
      # type: (Id_t, str) -> None
      self.id = id
      self.s = s
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> glob_part.Literal
      return glob_part.Literal(-1, '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('glob_part.Literal')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
      L.append(Field('id', x0))
  
      x1 = NewLeaf(self.s, color_e.StringConst)
      L.append(Field('s', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('glob_part.Literal')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
      L.append(Field('id', x0))
  
      x1 = NewLeaf(self.s, color_e.StringConst)
      L.append(Field('s', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Operator(glob_part_t):
    _type_tag = 2
    __slots__ = ('op_id',)
  
    def __init__(self, op_id):
      # type: (Id_t) -> None
      self.op_id = op_id
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> glob_part.Operator
      return glob_part.Operator(-1)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('glob_part.Operator')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('glob_part.Operator')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.op_id), color_e.UserType)
      L.append(Field('op_id', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class CharClass(glob_part_t):
    _type_tag = 3
    __slots__ = ('negated', 'strs')
  
    def __init__(self, negated, strs):
      # type: (bool, List[str]) -> None
      self.negated = negated
      self.strs = strs
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> glob_part.CharClass
      return glob_part.CharClass(False, [] if alloc_lists else
                                 cast('List[str]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('glob_part.CharClass')
      L = out_node.fields
  
      x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
      L.append(Field('negated', x0))
  
      if self.strs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.strs:
          x1.children.append(NewLeaf(i1, color_e.StringConst))
        L.append(Field('strs', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('glob_part.CharClass')
      L = out_node.fields
      x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
      L.append(Field('negated', x0))
  
      if self.strs is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.strs:
          x1.children.append(NewLeaf(i1, color_e.StringConst))
        L.append(Field('strs', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class printf_part_e(object):
  Literal = 1
  Percent = 2

_printf_part_str = {
  1: 'printf_part.Literal',
  2: 'printf_part.Percent',
}

def printf_part_str(tag):
  # type: (int) -> str
  return _printf_part_str[tag]

class printf_part_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class printf_part(object):
  class Literal(printf_part_t):
    _type_tag = 1
    __slots__ = ('token',)
  
    def __init__(self, token):
      # type: (Token) -> None
      self.token = token
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> printf_part.Literal
      return printf_part.Literal(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('printf_part.Literal')
      L = out_node.fields
  
      assert self.token is not None
      x0 = self.token.PrettyTree()
      L.append(Field('token', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('printf_part.Literal')
      L = out_node.fields
      assert self.token is not None
      x0 = self.token.AbbreviatedTree()
      L.append(Field('token', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Percent(printf_part_t):
    _type_tag = 2
    __slots__ = ('flags', 'width', 'precision', 'type')
  
    def __init__(self, flags, width, precision, type):
      # type: (List[Token], Optional[Token], Optional[Token], Token) -> None
      self.flags = flags
      self.width = width
      self.precision = precision
      self.type = type
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> printf_part.Percent
      return printf_part.Percent([] if alloc_lists else cast('List[Token]',
                                 None), cast('Optional[Token]', None),
                                 cast('Optional[Token]', None), cast(Token,
                                 None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('printf_part.Percent')
      L = out_node.fields
  
      if self.flags is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.flags:
          x0.children.append(i0.PrettyTree())
        L.append(Field('flags', x0))
  
      if self.width is not None:  # Optional
        x1 = self.width.PrettyTree()
        L.append(Field('width', x1))
  
      if self.precision is not None:  # Optional
        x2 = self.precision.PrettyTree()
        L.append(Field('precision', x2))
  
      assert self.type is not None
      x3 = self.type.PrettyTree()
      L.append(Field('type', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('printf_part.Percent')
      L = out_node.fields
      if self.flags is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.flags:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('flags', x0))
  
      if self.width is not None:  # Optional
        x1 = self.width.AbbreviatedTree()
        L.append(Field('width', x1))
  
      if self.precision is not None:  # Optional
        x2 = self.precision.AbbreviatedTree()
        L.append(Field('precision', x2))
  
      assert self.type is not None
      x3 = self.type.AbbreviatedTree()
      L.append(Field('type', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class expr_context_t(pybase.SimpleObj):
  pass

class expr_context_e(object):
  Load = expr_context_t(1)
  Store = expr_context_t(2)
  Del = expr_context_t(3)
  AugLoad = expr_context_t(4)
  AugStore = expr_context_t(5)
  Param = expr_context_t(6)

_expr_context_str = {
  1: 'expr_context.Load',
  2: 'expr_context.Store',
  3: 'expr_context.Del',
  4: 'expr_context.AugLoad',
  5: 'expr_context.AugStore',
  6: 'expr_context.Param',
}

def expr_context_str(val):
  # type: (expr_context_t) -> str
  return _expr_context_str[val]

class place_expr_e(object):
  Var = 1
  Subscript = 92
  Attribute = 93

_place_expr_str = {
  1: 'place_expr.Var',
  92: 'place_expr.Subscript',
  93: 'place_expr.Attribute',
}

def place_expr_str(tag):
  # type: (int) -> str
  return _place_expr_str[tag]

class place_expr_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class place_expr(object):
  class Var(place_expr_t):
    _type_tag = 1
    __slots__ = ('name',)
  
    def __init__(self, name):
      # type: (Token) -> None
      self.name = name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> place_expr.Var
      return place_expr.Var(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('place_expr.Var')
      L = out_node.fields
  
      assert self.name is not None
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('place_expr.Var')
      L = out_node.fields
      assert self.name is not None
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class expr_e(object):
  Var = 1
  Const = 2
  ShArrayLiteral = 74
  RegexLiteral = 4
  SimpleVarSub = 72
  BracedVarSub = 69
  CommandSub = 73
  SingleQuoted = 71
  DoubleQuoted = 70
  BlockArg = 83
  Lambda = 11
  Unary = 12
  Binary = 13
  Compare = 14
  FuncCall = 15
  IfExp = 16
  Tuple = 17
  List = 18
  Dict = 19
  Implicit = 20
  ListComp = 21
  DictComp = 22
  GeneratorExp = 23
  Range = 24
  Slice = 25
  Subscript = 92
  Attribute = 93
  Spread = 28

_expr_str = {
  1: 'expr.Var',
  2: 'expr.Const',
  4: 'expr.RegexLiteral',
  11: 'expr.Lambda',
  12: 'expr.Unary',
  13: 'expr.Binary',
  14: 'expr.Compare',
  15: 'expr.FuncCall',
  16: 'expr.IfExp',
  17: 'expr.Tuple',
  18: 'expr.List',
  19: 'expr.Dict',
  20: 'expr.Implicit',
  21: 'expr.ListComp',
  22: 'expr.DictComp',
  23: 'expr.GeneratorExp',
  24: 'expr.Range',
  25: 'expr.Slice',
  28: 'expr.Spread',
  69: 'expr.BracedVarSub',
  70: 'expr.DoubleQuoted',
  71: 'expr.SingleQuoted',
  72: 'expr.SimpleVarSub',
  73: 'expr.CommandSub',
  74: 'expr.ShArrayLiteral',
  83: 'expr.BlockArg',
  92: 'expr.Subscript',
  93: 'expr.Attribute',
}

def expr_str(tag):
  # type: (int) -> str
  return _expr_str[tag]

class expr_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class expr__Implicit(expr_t):
  _type_tag = 20
  __slots__ = ()

  def __init__(self, ):
    # type: () -> None
    pass

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr__Implicit')
    L = out_node.fields

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('expr__Implicit')
    L = out_node.fields
    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class expr(object):
  class Var(expr_t):
    _type_tag = 1
    __slots__ = ('name',)
  
    def __init__(self, name):
      # type: (Token) -> None
      self.name = name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Var
      return expr.Var(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Var')
      L = out_node.fields
  
      assert self.name is not None
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Var')
      L = out_node.fields
      assert self.name is not None
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Const(expr_t):
    _type_tag = 2
    __slots__ = ('c',)
  
    def __init__(self, c):
      # type: (Token) -> None
      self.c = c
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Const
      return expr.Const(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Const')
      L = out_node.fields
  
      assert self.c is not None
      x0 = self.c.PrettyTree()
      L.append(Field('c', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Const')
      L = out_node.fields
      assert self.c is not None
      x0 = self.c.AbbreviatedTree()
      L.append(Field('c', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class RegexLiteral(expr_t):
    _type_tag = 4
    __slots__ = ('left', 'regex', 'flags', 'trans_pref')
  
    def __init__(self, left, regex, flags, trans_pref):
      # type: (Token, re_t, List[Token], Optional[Token]) -> None
      self.left = left
      self.regex = regex
      self.flags = flags
      self.trans_pref = trans_pref
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.RegexLiteral
      return expr.RegexLiteral(cast(Token, None), cast(re_t, None), [] if
                               alloc_lists else cast('List[Token]', None),
                               cast('Optional[Token]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.RegexLiteral')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      assert self.regex is not None
      x1 = self.regex.PrettyTree()
      L.append(Field('regex', x1))
  
      if self.flags is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.flags:
          x2.children.append(i2.PrettyTree())
        L.append(Field('flags', x2))
  
      if self.trans_pref is not None:  # Optional
        x3 = self.trans_pref.PrettyTree()
        L.append(Field('trans_pref', x3))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.RegexLiteral')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      assert self.regex is not None
      x1 = self.regex.AbbreviatedTree()
      L.append(Field('regex', x1))
  
      if self.flags is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.flags:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('flags', x2))
  
      if self.trans_pref is not None:  # Optional
        x3 = self.trans_pref.AbbreviatedTree()
        L.append(Field('trans_pref', x3))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Lambda(expr_t):
    _type_tag = 11
    __slots__ = ('params', 'body')
  
    def __init__(self, params, body):
      # type: (List[NameType], expr_t) -> None
      self.params = params
      self.body = body
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Lambda
      return expr.Lambda([] if alloc_lists else cast('List[NameType]', None),
                         cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Lambda')
      L = out_node.fields
  
      if self.params is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.params:
          x0.children.append(i0.PrettyTree())
        L.append(Field('params', x0))
  
      assert self.body is not None
      x1 = self.body.PrettyTree()
      L.append(Field('body', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Lambda')
      L = out_node.fields
      if self.params is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.params:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('params', x0))
  
      assert self.body is not None
      x1 = self.body.AbbreviatedTree()
      L.append(Field('body', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Unary(expr_t):
    _type_tag = 12
    __slots__ = ('op', 'child')
  
    def __init__(self, op, child):
      # type: (Token, expr_t) -> None
      self.op = op
      self.child = child
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Unary
      return expr.Unary(cast(Token, None), cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Unary')
      L = out_node.fields
  
      assert self.op is not None
      x0 = self.op.PrettyTree()
      L.append(Field('op', x0))
  
      assert self.child is not None
      x1 = self.child.PrettyTree()
      L.append(Field('child', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Unary')
      L = out_node.fields
      assert self.op is not None
      x0 = self.op.AbbreviatedTree()
      L.append(Field('op', x0))
  
      assert self.child is not None
      x1 = self.child.AbbreviatedTree()
      L.append(Field('child', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Binary(expr_t):
    _type_tag = 13
    __slots__ = ('op', 'left', 'right')
  
    def __init__(self, op, left, right):
      # type: (Token, expr_t, expr_t) -> None
      self.op = op
      self.left = left
      self.right = right
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Binary
      return expr.Binary(cast(Token, None), cast(expr_t, None), cast(expr_t,
                         None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Binary')
      L = out_node.fields
  
      assert self.op is not None
      x0 = self.op.PrettyTree()
      L.append(Field('op', x0))
  
      assert self.left is not None
      x1 = self.left.PrettyTree()
      L.append(Field('left', x1))
  
      assert self.right is not None
      x2 = self.right.PrettyTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Binary')
      L = out_node.fields
      assert self.op is not None
      x0 = self.op.AbbreviatedTree()
      L.append(Field('op', x0))
  
      assert self.left is not None
      x1 = self.left.AbbreviatedTree()
      L.append(Field('left', x1))
  
      assert self.right is not None
      x2 = self.right.AbbreviatedTree()
      L.append(Field('right', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Compare(expr_t):
    _type_tag = 14
    __slots__ = ('left', 'ops', 'comparators')
  
    def __init__(self, left, ops, comparators):
      # type: (expr_t, List[Token], List[expr_t]) -> None
      self.left = left
      self.ops = ops
      self.comparators = comparators
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Compare
      return expr.Compare(cast(expr_t, None), [] if alloc_lists else
                          cast('List[Token]', None), [] if alloc_lists else
                          cast('List[expr_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Compare')
      L = out_node.fields
  
      assert self.left is not None
      x0 = self.left.PrettyTree()
      L.append(Field('left', x0))
  
      if self.ops is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.ops:
          x1.children.append(i1.PrettyTree())
        L.append(Field('ops', x1))
  
      if self.comparators is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.comparators:
          x2.children.append(i2.PrettyTree())
        L.append(Field('comparators', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Compare')
      L = out_node.fields
      assert self.left is not None
      x0 = self.left.AbbreviatedTree()
      L.append(Field('left', x0))
  
      if self.ops is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.ops:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('ops', x1))
  
      if self.comparators is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.comparators:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('comparators', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class FuncCall(expr_t):
    _type_tag = 15
    __slots__ = ('func', 'args')
  
    def __init__(self, func, args):
      # type: (expr_t, ArgList) -> None
      self.func = func
      self.args = args
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.FuncCall
      return expr.FuncCall(cast(expr_t, None), cast(ArgList, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.FuncCall')
      L = out_node.fields
  
      assert self.func is not None
      x0 = self.func.PrettyTree()
      L.append(Field('func', x0))
  
      assert self.args is not None
      x1 = self.args.PrettyTree()
      L.append(Field('args', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.FuncCall')
      L = out_node.fields
      assert self.func is not None
      x0 = self.func.AbbreviatedTree()
      L.append(Field('func', x0))
  
      assert self.args is not None
      x1 = self.args.AbbreviatedTree()
      L.append(Field('args', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class IfExp(expr_t):
    _type_tag = 16
    __slots__ = ('test', 'body', 'orelse')
  
    def __init__(self, test, body, orelse):
      # type: (expr_t, expr_t, expr_t) -> None
      self.test = test
      self.body = body
      self.orelse = orelse
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.IfExp
      return expr.IfExp(cast(expr_t, None), cast(expr_t, None), cast(expr_t,
                        None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.IfExp')
      L = out_node.fields
  
      assert self.test is not None
      x0 = self.test.PrettyTree()
      L.append(Field('test', x0))
  
      assert self.body is not None
      x1 = self.body.PrettyTree()
      L.append(Field('body', x1))
  
      assert self.orelse is not None
      x2 = self.orelse.PrettyTree()
      L.append(Field('orelse', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.IfExp')
      L = out_node.fields
      assert self.test is not None
      x0 = self.test.AbbreviatedTree()
      L.append(Field('test', x0))
  
      assert self.body is not None
      x1 = self.body.AbbreviatedTree()
      L.append(Field('body', x1))
  
      assert self.orelse is not None
      x2 = self.orelse.AbbreviatedTree()
      L.append(Field('orelse', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Tuple(expr_t):
    _type_tag = 17
    __slots__ = ('elts', 'ctx')
  
    def __init__(self, elts, ctx):
      # type: (List[expr_t], expr_context_t) -> None
      self.elts = elts
      self.ctx = ctx
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Tuple
      return expr.Tuple([] if alloc_lists else cast('List[expr_t]', None),
                        expr_context_e.Load)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Tuple')
      L = out_node.fields
  
      if self.elts is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.elts:
          x0.children.append(i0.PrettyTree())
        L.append(Field('elts', x0))
  
      x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
      L.append(Field('ctx', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Tuple')
      L = out_node.fields
      if self.elts is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.elts:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('elts', x0))
  
      x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
      L.append(Field('ctx', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class List(expr_t):
    _type_tag = 18
    __slots__ = ('elts', 'ctx')
  
    def __init__(self, elts, ctx):
      # type: (List[expr_t], expr_context_t) -> None
      self.elts = elts
      self.ctx = ctx
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.List
      return expr.List([] if alloc_lists else cast('List[expr_t]', None),
                       expr_context_e.Load)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.List')
      L = out_node.fields
  
      if self.elts is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.elts:
          x0.children.append(i0.PrettyTree())
        L.append(Field('elts', x0))
  
      x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
      L.append(Field('ctx', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.List')
      L = out_node.fields
      if self.elts is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.elts:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('elts', x0))
  
      x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
      L.append(Field('ctx', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Dict(expr_t):
    _type_tag = 19
    __slots__ = ('keys', 'values')
  
    def __init__(self, keys, values):
      # type: (List[expr_t], List[expr_t]) -> None
      self.keys = keys
      self.values = values
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Dict
      return expr.Dict([] if alloc_lists else cast('List[expr_t]', None), [] if
                       alloc_lists else cast('List[expr_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Dict')
      L = out_node.fields
  
      if self.keys is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.keys:
          x0.children.append(i0.PrettyTree())
        L.append(Field('keys', x0))
  
      if self.values is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.values:
          x1.children.append(i1.PrettyTree())
        L.append(Field('values', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Dict')
      L = out_node.fields
      if self.keys is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.keys:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('keys', x0))
  
      if self.values is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.values:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('values', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  Implicit = expr__Implicit()
  
  class ListComp(expr_t):
    _type_tag = 21
    __slots__ = ('elt', 'generators')
  
    def __init__(self, elt, generators):
      # type: (expr_t, List[Comprehension]) -> None
      self.elt = elt
      self.generators = generators
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.ListComp
      return expr.ListComp(cast(expr_t, None), [] if alloc_lists else
                           cast('List[Comprehension]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.ListComp')
      L = out_node.fields
  
      assert self.elt is not None
      x0 = self.elt.PrettyTree()
      L.append(Field('elt', x0))
  
      if self.generators is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.generators:
          x1.children.append(i1.PrettyTree())
        L.append(Field('generators', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.ListComp')
      L = out_node.fields
      assert self.elt is not None
      x0 = self.elt.AbbreviatedTree()
      L.append(Field('elt', x0))
  
      if self.generators is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.generators:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('generators', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class DictComp(expr_t):
    _type_tag = 22
    __slots__ = ('key', 'value', 'generators')
  
    def __init__(self, key, value, generators):
      # type: (expr_t, expr_t, List[Comprehension]) -> None
      self.key = key
      self.value = value
      self.generators = generators
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.DictComp
      return expr.DictComp(cast(expr_t, None), cast(expr_t, None), [] if
                           alloc_lists else cast('List[Comprehension]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.DictComp')
      L = out_node.fields
  
      assert self.key is not None
      x0 = self.key.PrettyTree()
      L.append(Field('key', x0))
  
      assert self.value is not None
      x1 = self.value.PrettyTree()
      L.append(Field('value', x1))
  
      if self.generators is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.generators:
          x2.children.append(i2.PrettyTree())
        L.append(Field('generators', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.DictComp')
      L = out_node.fields
      assert self.key is not None
      x0 = self.key.AbbreviatedTree()
      L.append(Field('key', x0))
  
      assert self.value is not None
      x1 = self.value.AbbreviatedTree()
      L.append(Field('value', x1))
  
      if self.generators is not None:  # List
        x2 = hnode.Array([])
        for i2 in self.generators:
          x2.children.append(i2.AbbreviatedTree())
        L.append(Field('generators', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class GeneratorExp(expr_t):
    _type_tag = 23
    __slots__ = ('elt', 'generators')
  
    def __init__(self, elt, generators):
      # type: (expr_t, List[Comprehension]) -> None
      self.elt = elt
      self.generators = generators
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.GeneratorExp
      return expr.GeneratorExp(cast(expr_t, None), [] if alloc_lists else
                               cast('List[Comprehension]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.GeneratorExp')
      L = out_node.fields
  
      assert self.elt is not None
      x0 = self.elt.PrettyTree()
      L.append(Field('elt', x0))
  
      if self.generators is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.generators:
          x1.children.append(i1.PrettyTree())
        L.append(Field('generators', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.GeneratorExp')
      L = out_node.fields
      assert self.elt is not None
      x0 = self.elt.AbbreviatedTree()
      L.append(Field('elt', x0))
  
      if self.generators is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.generators:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('generators', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Range(expr_t):
    _type_tag = 24
    __slots__ = ('lower', 'upper')
  
    def __init__(self, lower, upper):
      # type: (expr_t, expr_t) -> None
      self.lower = lower
      self.upper = upper
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Range
      return expr.Range(cast(expr_t, None), cast(expr_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Range')
      L = out_node.fields
  
      assert self.lower is not None
      x0 = self.lower.PrettyTree()
      L.append(Field('lower', x0))
  
      assert self.upper is not None
      x1 = self.upper.PrettyTree()
      L.append(Field('upper', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Range')
      L = out_node.fields
      assert self.lower is not None
      x0 = self.lower.AbbreviatedTree()
      L.append(Field('lower', x0))
  
      assert self.upper is not None
      x1 = self.upper.AbbreviatedTree()
      L.append(Field('upper', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Slice(expr_t):
    _type_tag = 25
    __slots__ = ('lower', 'upper')
  
    def __init__(self, lower, upper):
      # type: (Optional[expr_t], Optional[expr_t]) -> None
      self.lower = lower
      self.upper = upper
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Slice
      return expr.Slice(cast('Optional[expr_t]', None),
                        cast('Optional[expr_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Slice')
      L = out_node.fields
  
      if self.lower is not None:  # Optional
        x0 = self.lower.PrettyTree()
        L.append(Field('lower', x0))
  
      if self.upper is not None:  # Optional
        x1 = self.upper.PrettyTree()
        L.append(Field('upper', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Slice')
      L = out_node.fields
      if self.lower is not None:  # Optional
        x0 = self.lower.AbbreviatedTree()
        L.append(Field('lower', x0))
  
      if self.upper is not None:  # Optional
        x1 = self.upper.AbbreviatedTree()
        L.append(Field('upper', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Spread(expr_t):
    _type_tag = 28
    __slots__ = ('child', 'ctx')
  
    def __init__(self, child, ctx):
      # type: (expr_t, expr_context_t) -> None
      self.child = child
      self.ctx = ctx
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> expr.Spread
      return expr.Spread(cast(expr_t, None), expr_context_e.Load)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Spread')
      L = out_node.fields
  
      assert self.child is not None
      x0 = self.child.PrettyTree()
      L.append(Field('child', x0))
  
      x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
      L.append(Field('ctx', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('expr.Spread')
      L = out_node.fields
      assert self.child is not None
      x0 = self.child.AbbreviatedTree()
      L.append(Field('child', x0))
  
      x1 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
      L.append(Field('ctx', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class class_literal_term_e(object):
  PosixClass = 94
  PerlClass = 95
  Range = 3
  CharLiteral = 4
  SingleQuoted = 71
  Splice = 6

_class_literal_term_str = {
  3: 'class_literal_term.Range',
  4: 'class_literal_term.CharLiteral',
  6: 'class_literal_term.Splice',
  71: 'class_literal_term.SingleQuoted',
  94: 'class_literal_term.PosixClass',
  95: 'class_literal_term.PerlClass',
}

def class_literal_term_str(tag):
  # type: (int) -> str
  return _class_literal_term_str[tag]

class class_literal_term_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class class_literal_term(object):
  class Range(class_literal_term_t):
    _type_tag = 3
    __slots__ = ('start', 'end')
  
    def __init__(self, start, end):
      # type: (Token, Token) -> None
      self.start = start
      self.end = end
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> class_literal_term.Range
      return class_literal_term.Range(cast(Token, None), cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('class_literal_term.Range')
      L = out_node.fields
  
      assert self.start is not None
      x0 = self.start.PrettyTree()
      L.append(Field('start', x0))
  
      assert self.end is not None
      x1 = self.end.PrettyTree()
      L.append(Field('end', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('class_literal_term.Range')
      L = out_node.fields
      assert self.start is not None
      x0 = self.start.AbbreviatedTree()
      L.append(Field('start', x0))
  
      assert self.end is not None
      x1 = self.end.AbbreviatedTree()
      L.append(Field('end', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class CharLiteral(class_literal_term_t):
    _type_tag = 4
    __slots__ = ('tok',)
  
    def __init__(self, tok):
      # type: (Token) -> None
      self.tok = tok
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> class_literal_term.CharLiteral
      return class_literal_term.CharLiteral(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('class_literal_term.CharLiteral')
      L = out_node.fields
  
      assert self.tok is not None
      x0 = self.tok.PrettyTree()
      L.append(Field('tok', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('class_literal_term.CharLiteral')
      L = out_node.fields
      assert self.tok is not None
      x0 = self.tok.AbbreviatedTree()
      L.append(Field('tok', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Splice(class_literal_term_t):
    _type_tag = 6
    __slots__ = ('name', 'var_name')
  
    def __init__(self, name, var_name):
      # type: (Token, str) -> None
      self.name = name
      self.var_name = var_name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> class_literal_term.Splice
      return class_literal_term.Splice(cast(Token, None), '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('class_literal_term.Splice')
      L = out_node.fields
  
      assert self.name is not None
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))
  
      x1 = NewLeaf(self.var_name, color_e.StringConst)
      L.append(Field('var_name', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('class_literal_term.Splice')
      L = out_node.fields
      assert self.name is not None
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))
  
      x1 = NewLeaf(self.var_name, color_e.StringConst)
      L.append(Field('var_name', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class char_class_term_e(object):
  PosixClass = 94
  PerlClass = 95
  Range = 3
  CharCode = 96

_char_class_term_str = {
  3: 'char_class_term.Range',
  94: 'char_class_term.PosixClass',
  95: 'char_class_term.PerlClass',
  96: 'char_class_term.CharCode',
}

def char_class_term_str(tag):
  # type: (int) -> str
  return _char_class_term_str[tag]

class char_class_term_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class char_class_term(object):
  class Range(char_class_term_t):
    _type_tag = 3
    __slots__ = ('start', 'end')
  
    def __init__(self, start, end):
      # type: (CharCode, CharCode) -> None
      self.start = start
      self.end = end
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> char_class_term.Range
      return char_class_term.Range(cast(CharCode, None), cast(CharCode, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('char_class_term.Range')
      L = out_node.fields
  
      assert self.start is not None
      x0 = self.start.PrettyTree()
      L.append(Field('start', x0))
  
      assert self.end is not None
      x1 = self.end.PrettyTree()
      L.append(Field('end', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('char_class_term.Range')
      L = out_node.fields
      assert self.start is not None
      x0 = self.start.AbbreviatedTree()
      L.append(Field('start', x0))
  
      assert self.end is not None
      x1 = self.end.AbbreviatedTree()
      L.append(Field('end', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class re_repeat_e(object):
  Op = 1
  Num = 2
  Range = 3

_re_repeat_str = {
  1: 're_repeat.Op',
  2: 're_repeat.Num',
  3: 're_repeat.Range',
}

def re_repeat_str(tag):
  # type: (int) -> str
  return _re_repeat_str[tag]

class re_repeat_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class re_repeat(object):
  class Op(re_repeat_t):
    _type_tag = 1
    __slots__ = ('op',)
  
    def __init__(self, op):
      # type: (Token) -> None
      self.op = op
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re_repeat.Op
      return re_repeat.Op(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re_repeat.Op')
      L = out_node.fields
  
      assert self.op is not None
      x0 = self.op.PrettyTree()
      L.append(Field('op', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re_repeat.Op')
      L = out_node.fields
      assert self.op is not None
      x0 = self.op.AbbreviatedTree()
      L.append(Field('op', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Num(re_repeat_t):
    _type_tag = 2
    __slots__ = ('times',)
  
    def __init__(self, times):
      # type: (Token) -> None
      self.times = times
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re_repeat.Num
      return re_repeat.Num(cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re_repeat.Num')
      L = out_node.fields
  
      assert self.times is not None
      x0 = self.times.PrettyTree()
      L.append(Field('times', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re_repeat.Num')
      L = out_node.fields
      assert self.times is not None
      x0 = self.times.AbbreviatedTree()
      L.append(Field('times', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Range(re_repeat_t):
    _type_tag = 3
    __slots__ = ('lower', 'upper')
  
    def __init__(self, lower, upper):
      # type: (Optional[Token], Optional[Token]) -> None
      self.lower = lower
      self.upper = upper
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re_repeat.Range
      return re_repeat.Range(cast('Optional[Token]', None),
                             cast('Optional[Token]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re_repeat.Range')
      L = out_node.fields
  
      if self.lower is not None:  # Optional
        x0 = self.lower.PrettyTree()
        L.append(Field('lower', x0))
  
      if self.upper is not None:  # Optional
        x1 = self.upper.PrettyTree()
        L.append(Field('upper', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re_repeat.Range')
      L = out_node.fields
      if self.lower is not None:  # Optional
        x0 = self.lower.AbbreviatedTree()
        L.append(Field('lower', x0))
  
      if self.upper is not None:  # Optional
        x1 = self.upper.AbbreviatedTree()
        L.append(Field('upper', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class re_e(object):
  Token = 67
  PosixClass = 94
  PerlClass = 95
  CharClassLiteral = 4
  CharClass = 5
  Splice = 6
  SingleQuoted = 71
  Repeat = 8
  Seq = 9
  Alt = 10
  Group = 11
  Capture = 12
  Backtracking = 13
  Primitive = 14
  LiteralChars = 15

_re_str = {
  4: 're.CharClassLiteral',
  5: 're.CharClass',
  6: 're.Splice',
  8: 're.Repeat',
  9: 're.Seq',
  10: 're.Alt',
  11: 're.Group',
  12: 're.Capture',
  13: 're.Backtracking',
  14: 're.Primitive',
  15: 're.LiteralChars',
  67: 're.Token',
  71: 're.SingleQuoted',
  94: 're.PosixClass',
  95: 're.PerlClass',
}

def re_str(tag):
  # type: (int) -> str
  return _re_str[tag]

class re_t(pybase.CompoundObj):
  def tag(self):
    # type: () -> int
    return self._type_tag
  pass

class re(object):
  class CharClassLiteral(re_t):
    _type_tag = 4
    __slots__ = ('negated', 'terms')
  
    def __init__(self, negated, terms):
      # type: (bool, List[class_literal_term_t]) -> None
      self.negated = negated
      self.terms = terms
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.CharClassLiteral
      return re.CharClassLiteral(False, [] if alloc_lists else
                                 cast('List[class_literal_term_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.CharClassLiteral')
      L = out_node.fields
  
      x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
      L.append(Field('negated', x0))
  
      if self.terms is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.terms:
          x1.children.append(i1.PrettyTree())
        L.append(Field('terms', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.CharClassLiteral')
      L = out_node.fields
      x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
      L.append(Field('negated', x0))
  
      if self.terms is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.terms:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('terms', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class CharClass(re_t):
    _type_tag = 5
    __slots__ = ('negated', 'terms')
  
    def __init__(self, negated, terms):
      # type: (bool, List[char_class_term_t]) -> None
      self.negated = negated
      self.terms = terms
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.CharClass
      return re.CharClass(False, [] if alloc_lists else
                          cast('List[char_class_term_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.CharClass')
      L = out_node.fields
  
      x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
      L.append(Field('negated', x0))
  
      if self.terms is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.terms:
          x1.children.append(i1.PrettyTree())
        L.append(Field('terms', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.CharClass')
      L = out_node.fields
      x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
      L.append(Field('negated', x0))
  
      if self.terms is not None:  # List
        x1 = hnode.Array([])
        for i1 in self.terms:
          x1.children.append(i1.AbbreviatedTree())
        L.append(Field('terms', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Splice(re_t):
    _type_tag = 6
    __slots__ = ('name', 'var_name')
  
    def __init__(self, name, var_name):
      # type: (Token, str) -> None
      self.name = name
      self.var_name = var_name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.Splice
      return re.Splice(cast(Token, None), '')
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Splice')
      L = out_node.fields
  
      assert self.name is not None
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))
  
      x1 = NewLeaf(self.var_name, color_e.StringConst)
      L.append(Field('var_name', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Splice')
      L = out_node.fields
      assert self.name is not None
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))
  
      x1 = NewLeaf(self.var_name, color_e.StringConst)
      L.append(Field('var_name', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Repeat(re_t):
    _type_tag = 8
    __slots__ = ('child', 'op')
  
    def __init__(self, child, op):
      # type: (re_t, re_repeat_t) -> None
      self.child = child
      self.op = op
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.Repeat
      return re.Repeat(cast(re_t, None), cast(re_repeat_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Repeat')
      L = out_node.fields
  
      assert self.child is not None
      x0 = self.child.PrettyTree()
      L.append(Field('child', x0))
  
      assert self.op is not None
      x1 = self.op.PrettyTree()
      L.append(Field('op', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Repeat')
      L = out_node.fields
      assert self.child is not None
      x0 = self.child.AbbreviatedTree()
      L.append(Field('child', x0))
  
      assert self.op is not None
      x1 = self.op.AbbreviatedTree()
      L.append(Field('op', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Seq(re_t):
    _type_tag = 9
    __slots__ = ('children',)
  
    def __init__(self, children):
      # type: (List[re_t]) -> None
      self.children = children
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.Seq
      return re.Seq([] if alloc_lists else cast('List[re_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Seq')
      L = out_node.fields
  
      if self.children is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.children:
          x0.children.append(i0.PrettyTree())
        L.append(Field('children', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Seq')
      L = out_node.fields
      if self.children is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.children:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('children', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Alt(re_t):
    _type_tag = 10
    __slots__ = ('children',)
  
    def __init__(self, children):
      # type: (List[re_t]) -> None
      self.children = children
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.Alt
      return re.Alt([] if alloc_lists else cast('List[re_t]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Alt')
      L = out_node.fields
  
      if self.children is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.children:
          x0.children.append(i0.PrettyTree())
        L.append(Field('children', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Alt')
      L = out_node.fields
      if self.children is not None:  # List
        x0 = hnode.Array([])
        for i0 in self.children:
          x0.children.append(i0.AbbreviatedTree())
        L.append(Field('children', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Group(re_t):
    _type_tag = 11
    __slots__ = ('child',)
  
    def __init__(self, child):
      # type: (re_t) -> None
      self.child = child
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.Group
      return re.Group(cast(re_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Group')
      L = out_node.fields
  
      assert self.child is not None
      x0 = self.child.PrettyTree()
      L.append(Field('child', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Group')
      L = out_node.fields
      assert self.child is not None
      x0 = self.child.AbbreviatedTree()
      L.append(Field('child', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Capture(re_t):
    _type_tag = 12
    __slots__ = ('child', 'var_name')
  
    def __init__(self, child, var_name):
      # type: (re_t, Optional[Token]) -> None
      self.child = child
      self.var_name = var_name
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.Capture
      return re.Capture(cast(re_t, None), cast('Optional[Token]', None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Capture')
      L = out_node.fields
  
      assert self.child is not None
      x0 = self.child.PrettyTree()
      L.append(Field('child', x0))
  
      if self.var_name is not None:  # Optional
        x1 = self.var_name.PrettyTree()
        L.append(Field('var_name', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Capture')
      L = out_node.fields
      assert self.child is not None
      x0 = self.child.AbbreviatedTree()
      L.append(Field('child', x0))
  
      if self.var_name is not None:  # Optional
        x1 = self.var_name.AbbreviatedTree()
        L.append(Field('var_name', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Backtracking(re_t):
    _type_tag = 13
    __slots__ = ('negated', 'name', 'child')
  
    def __init__(self, negated, name, child):
      # type: (bool, Token, re_t) -> None
      self.negated = negated
      self.name = name
      self.child = child
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.Backtracking
      return re.Backtracking(False, cast(Token, None), cast(re_t, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Backtracking')
      L = out_node.fields
  
      x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
      L.append(Field('negated', x0))
  
      assert self.name is not None
      x1 = self.name.PrettyTree()
      L.append(Field('name', x1))
  
      assert self.child is not None
      x2 = self.child.PrettyTree()
      L.append(Field('child', x2))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Backtracking')
      L = out_node.fields
      x0 = hnode.Leaf('T' if self.negated else 'F', color_e.OtherConst)
      L.append(Field('negated', x0))
  
      assert self.name is not None
      x1 = self.name.AbbreviatedTree()
      L.append(Field('name', x1))
  
      assert self.child is not None
      x2 = self.child.AbbreviatedTree()
      L.append(Field('child', x2))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class Primitive(re_t):
    _type_tag = 14
    __slots__ = ('id',)
  
    def __init__(self, id):
      # type: (Id_t) -> None
      self.id = id
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.Primitive
      return re.Primitive(-1)
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Primitive')
      L = out_node.fields
  
      x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
      L.append(Field('id', x0))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.Primitive')
      L = out_node.fields
      x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
      L.append(Field('id', x0))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  
  class LiteralChars(re_t):
    _type_tag = 15
    __slots__ = ('s', 'blame_tok')
  
    def __init__(self, s, blame_tok):
      # type: (str, Token) -> None
      self.s = s
      self.blame_tok = blame_tok
  
    @staticmethod
    def CreateNull(alloc_lists=False):
      # type: () -> re.LiteralChars
      return re.LiteralChars('', cast(Token, None))
  
    def PrettyTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.LiteralChars')
      L = out_node.fields
  
      x0 = NewLeaf(self.s, color_e.StringConst)
      L.append(Field('s', x0))
  
      assert self.blame_tok is not None
      x1 = self.blame_tok.PrettyTree()
      L.append(Field('blame_tok', x1))
  
      return out_node
  
    def _AbbreviatedTree(self):
      # type: () -> hnode_t
      out_node = NewRecord('re.LiteralChars')
      L = out_node.fields
      x0 = NewLeaf(self.s, color_e.StringConst)
      L.append(Field('s', x0))
  
      assert self.blame_tok is not None
      x1 = self.blame_tok.AbbreviatedTree()
      L.append(Field('blame_tok', x1))
  
      return out_node
  
    def AbbreviatedTree(self):
      # type: () -> hnode_t
      return self._AbbreviatedTree()
  

class BoolParamBox(pybase.CompoundObj):
  _type_tag = 64
  __slots__ = ('b',)

  def __init__(self, b):
    # type: (bool) -> None
    self.b = b

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> BoolParamBox
    return BoolParamBox(False)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BoolParamBox')
    L = out_node.fields

    x0 = hnode.Leaf('T' if self.b else 'F', color_e.OtherConst)
    L.append(Field('b', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BoolParamBox')
    L = out_node.fields
    x0 = hnode.Leaf('T' if self.b else 'F', color_e.OtherConst)
    L.append(Field('b', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class IntParamBox(pybase.CompoundObj):
  _type_tag = 65
  __slots__ = ('i',)

  def __init__(self, i):
    # type: (int) -> None
    self.i = i

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> IntParamBox
    return IntParamBox(-1)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('IntParamBox')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.i), color_e.OtherConst)
    L.append(Field('i', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('IntParamBox')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.i), color_e.OtherConst)
    L.append(Field('i', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class SourceLine(pybase.CompoundObj):
  _type_tag = 66
  __slots__ = ('line_num', 'content', 'src')

  def __init__(self, line_num, content, src):
    # type: (int, str, source_t) -> None
    self.line_num = line_num
    self.content = content
    self.src = src

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> SourceLine
    return SourceLine(-1, '', cast(source_t, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('SourceLine')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.line_num), color_e.OtherConst)
    L.append(Field('line_num', x0))

    x1 = NewLeaf(self.content, color_e.StringConst)
    L.append(Field('content', x1))

    assert self.src is not None
    x2 = self.src.PrettyTree()
    L.append(Field('src', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('SourceLine')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.line_num), color_e.OtherConst)
    L.append(Field('line_num', x0))

    x1 = NewLeaf(self.content, color_e.StringConst)
    L.append(Field('content', x1))

    assert self.src is not None
    x2 = self.src.AbbreviatedTree()
    L.append(Field('src', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class Token(loc_t, suffix_op_t, word_part_t, word_t, re_t):
  _type_tag = 67
  __slots__ = ('id', 'col', 'length', 'span_id', 'line', 'tval')

  def __init__(self, id, col, length, span_id, line, tval):
    # type: (Id_t, int, int, int, Optional[SourceLine], str) -> None
    self.id = id
    self.col = col
    self.length = length
    self.span_id = span_id
    self.line = line
    self.tval = tval

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> Token
    return Token(-1, -1, -1, -1, cast('Optional[SourceLine]', None), '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Token')
    L = out_node.fields

    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(Field('id', x0))

    x1 = hnode.Leaf(str(self.col), color_e.OtherConst)
    L.append(Field('col', x1))

    x2 = hnode.Leaf(str(self.length), color_e.OtherConst)
    L.append(Field('length', x2))

    x3 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(Field('span_id', x3))

    if self.line is not None:  # Optional
      x4 = self.line.PrettyTree()
      L.append(Field('line', x4))

    x5 = NewLeaf(self.tval, color_e.StringConst)
    L.append(Field('tval', x5))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Token')
    L = out_node.fields
    x0 = hnode.Leaf(Id_str(self.id), color_e.UserType)
    L.append(Field('id', x0))

    x1 = hnode.Leaf(str(self.col), color_e.OtherConst)
    L.append(Field('col', x1))

    x2 = hnode.Leaf(str(self.length), color_e.OtherConst)
    L.append(Field('length', x2))

    x3 = hnode.Leaf(str(self.span_id), color_e.OtherConst)
    L.append(Field('span_id', x3))

    if self.line is not None:  # Optional
      x4 = self.line.AbbreviatedTree()
      L.append(Field('line', x4))

    x5 = NewLeaf(self.tval, color_e.StringConst)
    L.append(Field('tval', x5))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _Token(self)
    return p if p else self._AbbreviatedTree()

class CompoundWord(loc_t, rhs_word_t, word_t, arith_expr_t, redir_param_t):
  _type_tag = 68
  __slots__ = ('parts',)

  def __init__(self, parts):
    # type: (List[word_part_t]) -> None
    self.parts = parts

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> CompoundWord
    return CompoundWord([] if alloc_lists else cast('List[word_part_t]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CompoundWord')
    L = out_node.fields

    if self.parts is not None:  # List
      x0 = hnode.Array([])
      for i0 in self.parts:
        x0.children.append(i0.PrettyTree())
      L.append(Field('parts', x0))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CompoundWord')
    L = out_node.fields
    if self.parts is not None:  # List
      x0 = hnode.Array([])
      for i0 in self.parts:
        x0.children.append(i0.AbbreviatedTree())
      L.append(Field('parts', x0))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _CompoundWord(self)
    return p if p else self._AbbreviatedTree()

class BracedVarSub(word_part_t, expr_t):
  _type_tag = 69
  __slots__ = ('left', 'token', 'var_name', 'prefix_op', 'bracket_op',
               'suffix_op', 'right')

  def __init__(self, left, token, var_name, prefix_op, bracket_op, suffix_op,
               right):
    # type: (Token, Token, str, Optional[Token], Optional[bracket_op_t], Optional[suffix_op_t], Token) -> None
    self.left = left
    self.token = token
    self.var_name = var_name
    self.prefix_op = prefix_op
    self.bracket_op = bracket_op
    self.suffix_op = suffix_op
    self.right = right

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> BracedVarSub
    return BracedVarSub(cast(Token, None), cast(Token, None), '',
                        cast('Optional[Token]', None),
                        cast('Optional[bracket_op_t]', None),
                        cast('Optional[suffix_op_t]', None), cast(Token, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BracedVarSub')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    assert self.token is not None
    x1 = self.token.PrettyTree()
    L.append(Field('token', x1))

    x2 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(Field('var_name', x2))

    if self.prefix_op is not None:  # Optional
      x3 = self.prefix_op.PrettyTree()
      L.append(Field('prefix_op', x3))

    if self.bracket_op is not None:  # Optional
      x4 = self.bracket_op.PrettyTree()
      L.append(Field('bracket_op', x4))

    if self.suffix_op is not None:  # Optional
      x5 = self.suffix_op.PrettyTree()
      L.append(Field('suffix_op', x5))

    assert self.right is not None
    x6 = self.right.PrettyTree()
    L.append(Field('right', x6))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BracedVarSub')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    assert self.token is not None
    x1 = self.token.AbbreviatedTree()
    L.append(Field('token', x1))

    x2 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(Field('var_name', x2))

    if self.prefix_op is not None:  # Optional
      x3 = self.prefix_op.AbbreviatedTree()
      L.append(Field('prefix_op', x3))

    if self.bracket_op is not None:  # Optional
      x4 = self.bracket_op.AbbreviatedTree()
      L.append(Field('bracket_op', x4))

    if self.suffix_op is not None:  # Optional
      x5 = self.suffix_op.AbbreviatedTree()
      L.append(Field('suffix_op', x5))

    assert self.right is not None
    x6 = self.right.AbbreviatedTree()
    L.append(Field('right', x6))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _BracedVarSub(self)
    return p if p else self._AbbreviatedTree()

class DoubleQuoted(word_part_t, expr_t):
  _type_tag = 70
  __slots__ = ('left', 'parts', 'right')

  def __init__(self, left, parts, right):
    # type: (Token, List[word_part_t], Token) -> None
    self.left = left
    self.parts = parts
    self.right = right

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> DoubleQuoted
    return DoubleQuoted(cast(Token, None), [] if alloc_lists else
                        cast('List[word_part_t]', None), cast(Token, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('DoubleQuoted')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    if self.parts is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.parts:
        x1.children.append(i1.PrettyTree())
      L.append(Field('parts', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(Field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('DoubleQuoted')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    if self.parts is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.parts:
        x1.children.append(i1.AbbreviatedTree())
      L.append(Field('parts', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(Field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _DoubleQuoted(self)
    return p if p else self._AbbreviatedTree()

class SingleQuoted(word_part_t, expr_t, class_literal_term_t, re_t):
  _type_tag = 71
  __slots__ = ('left', 'tokens', 'right')

  def __init__(self, left, tokens, right):
    # type: (Token, List[Token], Token) -> None
    self.left = left
    self.tokens = tokens
    self.right = right

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> SingleQuoted
    return SingleQuoted(cast(Token, None), [] if alloc_lists else
                        cast('List[Token]', None), cast(Token, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('SingleQuoted')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    if self.tokens is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.tokens:
        x1.children.append(i1.PrettyTree())
      L.append(Field('tokens', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(Field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('SingleQuoted')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    if self.tokens is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.tokens:
        x1.children.append(i1.AbbreviatedTree())
      L.append(Field('tokens', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(Field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _SingleQuoted(self)
    return p if p else self._AbbreviatedTree()

class SimpleVarSub(word_part_t, arith_expr_t, expr_t):
  _type_tag = 72
  __slots__ = ('left', 'var_name')

  def __init__(self, left, var_name):
    # type: (Token, str) -> None
    self.left = left
    self.var_name = var_name

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> SimpleVarSub
    return SimpleVarSub(cast(Token, None), '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('SimpleVarSub')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    x1 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(Field('var_name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('SimpleVarSub')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    x1 = NewLeaf(self.var_name, color_e.StringConst)
    L.append(Field('var_name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    p = _SimpleVarSub(self)
    return p if p else self._AbbreviatedTree()

class CommandSub(word_part_t, expr_t):
  _type_tag = 73
  __slots__ = ('left_token', 'child', 'right')

  def __init__(self, left_token, child, right):
    # type: (Token, command_t, Token) -> None
    self.left_token = left_token
    self.child = child
    self.right = right

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> CommandSub
    return CommandSub(cast(Token, None), cast(command_t, None), cast(Token,
                      None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CommandSub')
    L = out_node.fields

    assert self.left_token is not None
    x0 = self.left_token.PrettyTree()
    L.append(Field('left_token', x0))

    assert self.child is not None
    x1 = self.child.PrettyTree()
    L.append(Field('child', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(Field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CommandSub')
    L = out_node.fields
    assert self.left_token is not None
    x0 = self.left_token.AbbreviatedTree()
    L.append(Field('left_token', x0))

    assert self.child is not None
    x1 = self.child.AbbreviatedTree()
    L.append(Field('child', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(Field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class ShArrayLiteral(word_part_t, expr_t):
  _type_tag = 74
  __slots__ = ('left', 'words', 'right')

  def __init__(self, left, words, right):
    # type: (Token, List[word_t], Token) -> None
    self.left = left
    self.words = words
    self.right = right

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> ShArrayLiteral
    return ShArrayLiteral(cast(Token, None), [] if alloc_lists else
                          cast('List[word_t]', None), cast(Token, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('ShArrayLiteral')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    if self.words is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.words:
        x1.children.append(i1.PrettyTree())
      L.append(Field('words', x1))

    assert self.right is not None
    x2 = self.right.PrettyTree()
    L.append(Field('right', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('ShArrayLiteral')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    if self.words is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.words:
        x1.children.append(i1.AbbreviatedTree())
      L.append(Field('words', x1))

    assert self.right is not None
    x2 = self.right.AbbreviatedTree()
    L.append(Field('right', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class ArgList(pybase.CompoundObj):
  _type_tag = 75
  __slots__ = ('left', 'pos_args', 'named_args', 'right')

  def __init__(self, left, pos_args, named_args, right):
    # type: (Token, List[expr_t], List[NamedArg], Token) -> None
    self.left = left
    self.pos_args = pos_args
    self.named_args = named_args
    self.right = right

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> ArgList
    return ArgList(cast(Token, None), [] if alloc_lists else
                   cast('List[expr_t]', None), [] if alloc_lists else
                   cast('List[NamedArg]', None), cast(Token, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('ArgList')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    if self.pos_args is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.pos_args:
        x1.children.append(i1.PrettyTree())
      L.append(Field('pos_args', x1))

    if self.named_args is not None:  # List
      x2 = hnode.Array([])
      for i2 in self.named_args:
        x2.children.append(i2.PrettyTree())
      L.append(Field('named_args', x2))

    assert self.right is not None
    x3 = self.right.PrettyTree()
    L.append(Field('right', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('ArgList')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    if self.pos_args is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.pos_args:
        x1.children.append(i1.AbbreviatedTree())
      L.append(Field('pos_args', x1))

    if self.named_args is not None:  # List
      x2 = hnode.Array([])
      for i2 in self.named_args:
        x2.children.append(i2.AbbreviatedTree())
      L.append(Field('named_args', x2))

    assert self.right is not None
    x3 = self.right.AbbreviatedTree()
    L.append(Field('right', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class AssocPair(pybase.CompoundObj):
  _type_tag = 76
  __slots__ = ('key', 'value')

  def __init__(self, key, value):
    # type: (CompoundWord, CompoundWord) -> None
    self.key = key
    self.value = value

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> AssocPair
    return AssocPair(cast(CompoundWord, None), cast(CompoundWord, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('AssocPair')
    L = out_node.fields

    assert self.key is not None
    x0 = self.key.PrettyTree()
    L.append(Field('key', x0))

    assert self.value is not None
    x1 = self.value.PrettyTree()
    L.append(Field('value', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('AssocPair')
    L = out_node.fields
    assert self.key is not None
    x0 = self.key.AbbreviatedTree()
    L.append(Field('key', x0))

    assert self.value is not None
    x1 = self.value.AbbreviatedTree()
    L.append(Field('value', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class Redir(pybase.CompoundObj):
  _type_tag = 77
  __slots__ = ('op', 'loc', 'arg')

  def __init__(self, op, loc, arg):
    # type: (Token, redir_loc_t, redir_param_t) -> None
    self.op = op
    self.loc = loc
    self.arg = arg

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> Redir
    return Redir(cast(Token, None), cast(redir_loc_t, None),
                 cast(redir_param_t, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Redir')
    L = out_node.fields

    assert self.op is not None
    x0 = self.op.PrettyTree()
    L.append(Field('op', x0))

    assert self.loc is not None
    x1 = self.loc.PrettyTree()
    L.append(Field('loc', x1))

    assert self.arg is not None
    x2 = self.arg.PrettyTree()
    L.append(Field('arg', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Redir')
    L = out_node.fields
    assert self.op is not None
    x0 = self.op.AbbreviatedTree()
    L.append(Field('op', x0))

    assert self.loc is not None
    x1 = self.loc.AbbreviatedTree()
    L.append(Field('loc', x1))

    assert self.arg is not None
    x2 = self.arg.AbbreviatedTree()
    L.append(Field('arg', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class AssignPair(pybase.CompoundObj):
  _type_tag = 78
  __slots__ = ('left', 'lhs', 'op', 'rhs')

  def __init__(self, left, lhs, op, rhs):
    # type: (Token, sh_lhs_expr_t, assign_op_t, rhs_word_t) -> None
    self.left = left
    self.lhs = lhs
    self.op = op
    self.rhs = rhs

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> AssignPair
    return AssignPair(cast(Token, None), cast(sh_lhs_expr_t, None),
                      assign_op_e.Equal, cast(rhs_word_t, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('AssignPair')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    assert self.lhs is not None
    x1 = self.lhs.PrettyTree()
    L.append(Field('lhs', x1))

    x2 = hnode.Leaf(assign_op_str(self.op), color_e.TypeName)
    L.append(Field('op', x2))

    assert self.rhs is not None
    x3 = self.rhs.PrettyTree()
    L.append(Field('rhs', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('AssignPair')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    assert self.lhs is not None
    x1 = self.lhs.AbbreviatedTree()
    L.append(Field('lhs', x1))

    x2 = hnode.Leaf(assign_op_str(self.op), color_e.TypeName)
    L.append(Field('op', x2))

    assert self.rhs is not None
    x3 = self.rhs.AbbreviatedTree()
    L.append(Field('rhs', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class EnvPair(pybase.CompoundObj):
  _type_tag = 79
  __slots__ = ('left', 'name', 'val')

  def __init__(self, left, name, val):
    # type: (Token, str, rhs_word_t) -> None
    self.left = left
    self.name = name
    self.val = val

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> EnvPair
    return EnvPair(cast(Token, None), '', cast(rhs_word_t, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('EnvPair')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    assert self.val is not None
    x2 = self.val.PrettyTree()
    L.append(Field('val', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('EnvPair')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    assert self.val is not None
    x2 = self.val.AbbreviatedTree()
    L.append(Field('val', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class CaseArm(pybase.CompoundObj):
  _type_tag = 80
  __slots__ = ('left', 'pattern', 'middle', 'action', 'right')

  def __init__(self, left, pattern, middle, action, right):
    # type: (Token, pat_t, Token, List[command_t], Optional[Token]) -> None
    self.left = left
    self.pattern = pattern
    self.middle = middle
    self.action = action
    self.right = right

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> CaseArm
    return CaseArm(cast(Token, None), cast(pat_t, None), cast(Token, None), []
                   if alloc_lists else cast('List[command_t]', None),
                   cast('Optional[Token]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CaseArm')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    assert self.pattern is not None
    x1 = self.pattern.PrettyTree()
    L.append(Field('pattern', x1))

    assert self.middle is not None
    x2 = self.middle.PrettyTree()
    L.append(Field('middle', x2))

    if self.action is not None:  # List
      x3 = hnode.Array([])
      for i3 in self.action:
        x3.children.append(i3.PrettyTree())
      L.append(Field('action', x3))

    if self.right is not None:  # Optional
      x4 = self.right.PrettyTree()
      L.append(Field('right', x4))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CaseArm')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    assert self.pattern is not None
    x1 = self.pattern.AbbreviatedTree()
    L.append(Field('pattern', x1))

    assert self.middle is not None
    x2 = self.middle.AbbreviatedTree()
    L.append(Field('middle', x2))

    if self.action is not None:  # List
      x3 = hnode.Array([])
      for i3 in self.action:
        x3.children.append(i3.AbbreviatedTree())
      L.append(Field('action', x3))

    if self.right is not None:  # Optional
      x4 = self.right.AbbreviatedTree()
      L.append(Field('right', x4))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class IfArm(pybase.CompoundObj):
  _type_tag = 81
  __slots__ = ('keyword', 'cond', 'then_kw', 'action', 'spids')

  def __init__(self, keyword, cond, then_kw, action, spids):
    # type: (Token, condition_t, Optional[Token], List[command_t], List[int]) -> None
    self.keyword = keyword
    self.cond = cond
    self.then_kw = then_kw
    self.action = action
    self.spids = spids

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> IfArm
    return IfArm(cast(Token, None), cast(condition_t, None),
                 cast('Optional[Token]', None), [] if alloc_lists else
                 cast('List[command_t]', None), [] if alloc_lists else
                 cast('List[int]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('IfArm')
    L = out_node.fields

    assert self.keyword is not None
    x0 = self.keyword.PrettyTree()
    L.append(Field('keyword', x0))

    assert self.cond is not None
    x1 = self.cond.PrettyTree()
    L.append(Field('cond', x1))

    if self.then_kw is not None:  # Optional
      x2 = self.then_kw.PrettyTree()
      L.append(Field('then_kw', x2))

    if self.action is not None:  # List
      x3 = hnode.Array([])
      for i3 in self.action:
        x3.children.append(i3.PrettyTree())
      L.append(Field('action', x3))

    if self.spids is not None:  # List
      x4 = hnode.Array([])
      for i4 in self.spids:
        x4.children.append(hnode.Leaf(str(i4), color_e.OtherConst))
      L.append(Field('spids', x4))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('IfArm')
    L = out_node.fields
    assert self.keyword is not None
    x0 = self.keyword.AbbreviatedTree()
    L.append(Field('keyword', x0))

    assert self.cond is not None
    x1 = self.cond.AbbreviatedTree()
    L.append(Field('cond', x1))

    if self.then_kw is not None:  # Optional
      x2 = self.then_kw.AbbreviatedTree()
      L.append(Field('then_kw', x2))

    if self.action is not None:  # List
      x3 = hnode.Array([])
      for i3 in self.action:
        x3.children.append(i3.AbbreviatedTree())
      L.append(Field('action', x3))

    if self.spids is not None:  # List
      x4 = hnode.Array([])
      for i4 in self.spids:
        x4.children.append(hnode.Leaf(str(i4), color_e.OtherConst))
      L.append(Field('spids', x4))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class BraceGroup(command_t):
  _type_tag = 82
  __slots__ = ('left', 'doc_token', 'children', 'redirects', 'right')

  def __init__(self, left, doc_token, children, redirects, right):
    # type: (Token, Optional[Token], List[command_t], List[Redir], Token) -> None
    self.left = left
    self.doc_token = doc_token
    self.children = children
    self.redirects = redirects
    self.right = right

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> BraceGroup
    return BraceGroup(cast(Token, None), cast('Optional[Token]', None), [] if
                      alloc_lists else cast('List[command_t]', None), [] if
                      alloc_lists else cast('List[Redir]', None), cast(Token,
                      None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BraceGroup')
    L = out_node.fields

    assert self.left is not None
    x0 = self.left.PrettyTree()
    L.append(Field('left', x0))

    if self.doc_token is not None:  # Optional
      x1 = self.doc_token.PrettyTree()
      L.append(Field('doc_token', x1))

    if self.children is not None:  # List
      x2 = hnode.Array([])
      for i2 in self.children:
        x2.children.append(i2.PrettyTree())
      L.append(Field('children', x2))

    if self.redirects is not None:  # List
      x3 = hnode.Array([])
      for i3 in self.redirects:
        x3.children.append(i3.PrettyTree())
      L.append(Field('redirects', x3))

    assert self.right is not None
    x4 = self.right.PrettyTree()
    L.append(Field('right', x4))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BraceGroup')
    L = out_node.fields
    assert self.left is not None
    x0 = self.left.AbbreviatedTree()
    L.append(Field('left', x0))

    if self.doc_token is not None:  # Optional
      x1 = self.doc_token.AbbreviatedTree()
      L.append(Field('doc_token', x1))

    if self.children is not None:  # List
      x2 = hnode.Array([])
      for i2 in self.children:
        x2.children.append(i2.AbbreviatedTree())
      L.append(Field('children', x2))

    if self.redirects is not None:  # List
      x3 = hnode.Array([])
      for i3 in self.redirects:
        x3.children.append(i3.AbbreviatedTree())
      L.append(Field('redirects', x3))

    assert self.right is not None
    x4 = self.right.AbbreviatedTree()
    L.append(Field('right', x4))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class BlockArg(expr_t):
  _type_tag = 83
  __slots__ = ('brace_group', 'lines')

  def __init__(self, brace_group, lines):
    # type: (BraceGroup, List[SourceLine]) -> None
    self.brace_group = brace_group
    self.lines = lines

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> BlockArg
    return BlockArg(cast(BraceGroup, None), [] if alloc_lists else
                    cast('List[SourceLine]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BlockArg')
    L = out_node.fields

    assert self.brace_group is not None
    x0 = self.brace_group.PrettyTree()
    L.append(Field('brace_group', x0))

    if self.lines is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.lines:
        x1.children.append(i1.PrettyTree())
      L.append(Field('lines', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('BlockArg')
    L = out_node.fields
    assert self.brace_group is not None
    x0 = self.brace_group.AbbreviatedTree()
    L.append(Field('brace_group', x0))

    if self.lines is not None:  # List
      x1 = hnode.Array([])
      for i1 in self.lines:
        x1.children.append(i1.AbbreviatedTree())
      L.append(Field('lines', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class Variant(pybase.CompoundObj):
  _type_tag = 84
  __slots__ = ('tag_name', 'typ')

  def __init__(self, tag_name, typ):
    # type: (Token, Optional[variant_type_t]) -> None
    self.tag_name = tag_name
    self.typ = typ

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> Variant
    return Variant(cast(Token, None), cast('Optional[variant_type_t]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Variant')
    L = out_node.fields

    assert self.tag_name is not None
    x0 = self.tag_name.PrettyTree()
    L.append(Field('tag_name', x0))

    if self.typ is not None:  # Optional
      x1 = self.typ.PrettyTree()
      L.append(Field('typ', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Variant')
    L = out_node.fields
    assert self.tag_name is not None
    x0 = self.tag_name.AbbreviatedTree()
    L.append(Field('tag_name', x0))

    if self.typ is not None:  # Optional
      x1 = self.typ.AbbreviatedTree()
      L.append(Field('typ', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class ImportName(pybase.CompoundObj):
  _type_tag = 85
  __slots__ = ('name', 'alias')

  def __init__(self, name, alias):
    # type: (Token, Optional[Token]) -> None
    self.name = name
    self.alias = alias

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> ImportName
    return ImportName(cast(Token, None), cast('Optional[Token]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('ImportName')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(Field('name', x0))

    if self.alias is not None:  # Optional
      x1 = self.alias.PrettyTree()
      L.append(Field('alias', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('ImportName')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(Field('name', x0))

    if self.alias is not None:  # Optional
      x1 = self.alias.AbbreviatedTree()
      L.append(Field('alias', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class Param(pybase.CompoundObj):
  _type_tag = 86
  __slots__ = ('blame_tok', 'name', 'type', 'default_val')

  def __init__(self, blame_tok, name, type, default_val):
    # type: (Token, str, Optional[TypeExpr], Optional[expr_t]) -> None
    self.blame_tok = blame_tok
    self.name = name
    self.type = type
    self.default_val = default_val

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> Param
    return Param(cast(Token, None), '', cast('Optional[TypeExpr]', None),
                 cast('Optional[expr_t]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Param')
    L = out_node.fields

    assert self.blame_tok is not None
    x0 = self.blame_tok.PrettyTree()
    L.append(Field('blame_tok', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    if self.type is not None:  # Optional
      x2 = self.type.PrettyTree()
      L.append(Field('type', x2))

    if self.default_val is not None:  # Optional
      x3 = self.default_val.PrettyTree()
      L.append(Field('default_val', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Param')
    L = out_node.fields
    assert self.blame_tok is not None
    x0 = self.blame_tok.AbbreviatedTree()
    L.append(Field('blame_tok', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    if self.type is not None:  # Optional
      x2 = self.type.AbbreviatedTree()
      L.append(Field('type', x2))

    if self.default_val is not None:  # Optional
      x3 = self.default_val.AbbreviatedTree()
      L.append(Field('default_val', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class RestParam(pybase.CompoundObj):
  _type_tag = 87
  __slots__ = ('blame_tok', 'name')

  def __init__(self, blame_tok, name):
    # type: (Token, str) -> None
    self.blame_tok = blame_tok
    self.name = name

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> RestParam
    return RestParam(cast(Token, None), '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('RestParam')
    L = out_node.fields

    assert self.blame_tok is not None
    x0 = self.blame_tok.PrettyTree()
    L.append(Field('blame_tok', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('RestParam')
    L = out_node.fields
    assert self.blame_tok is not None
    x0 = self.blame_tok.AbbreviatedTree()
    L.append(Field('blame_tok', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class TypeExpr(pybase.CompoundObj):
  _type_tag = 88
  __slots__ = ('tok', 'name', 'params')

  def __init__(self, tok, name, params):
    # type: (Token, str, List[TypeExpr]) -> None
    self.tok = tok
    self.name = name
    self.params = params

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> TypeExpr
    return TypeExpr(cast(Token, None), '', [] if alloc_lists else
                    cast('List[TypeExpr]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('TypeExpr')
    L = out_node.fields

    assert self.tok is not None
    x0 = self.tok.PrettyTree()
    L.append(Field('tok', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    if self.params is not None:  # List
      x2 = hnode.Array([])
      for i2 in self.params:
        x2.children.append(i2.PrettyTree())
      L.append(Field('params', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('TypeExpr')
    L = out_node.fields
    assert self.tok is not None
    x0 = self.tok.AbbreviatedTree()
    L.append(Field('tok', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    if self.params is not None:  # List
      x2 = hnode.Array([])
      for i2 in self.params:
        x2.children.append(i2.AbbreviatedTree())
      L.append(Field('params', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class NameType(pybase.CompoundObj):
  _type_tag = 89
  __slots__ = ('name', 'typ')

  def __init__(self, name, typ):
    # type: (Token, Optional[TypeExpr]) -> None
    self.name = name
    self.typ = typ

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> NameType
    return NameType(cast(Token, None), cast('Optional[TypeExpr]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('NameType')
    L = out_node.fields

    assert self.name is not None
    x0 = self.name.PrettyTree()
    L.append(Field('name', x0))

    if self.typ is not None:  # Optional
      x1 = self.typ.PrettyTree()
      L.append(Field('typ', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('NameType')
    L = out_node.fields
    assert self.name is not None
    x0 = self.name.AbbreviatedTree()
    L.append(Field('name', x0))

    if self.typ is not None:  # Optional
      x1 = self.typ.AbbreviatedTree()
      L.append(Field('typ', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class Comprehension(pybase.CompoundObj):
  _type_tag = 90
  __slots__ = ('lhs', 'iter', 'cond')

  def __init__(self, lhs, iter, cond):
    # type: (List[NameType], expr_t, Optional[expr_t]) -> None
    self.lhs = lhs
    self.iter = iter
    self.cond = cond

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> Comprehension
    return Comprehension([] if alloc_lists else cast('List[NameType]', None),
                         cast(expr_t, None), cast('Optional[expr_t]', None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Comprehension')
    L = out_node.fields

    if self.lhs is not None:  # List
      x0 = hnode.Array([])
      for i0 in self.lhs:
        x0.children.append(i0.PrettyTree())
      L.append(Field('lhs', x0))

    assert self.iter is not None
    x1 = self.iter.PrettyTree()
    L.append(Field('iter', x1))

    if self.cond is not None:  # Optional
      x2 = self.cond.PrettyTree()
      L.append(Field('cond', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Comprehension')
    L = out_node.fields
    if self.lhs is not None:  # List
      x0 = hnode.Array([])
      for i0 in self.lhs:
        x0.children.append(i0.AbbreviatedTree())
      L.append(Field('lhs', x0))

    assert self.iter is not None
    x1 = self.iter.AbbreviatedTree()
    L.append(Field('iter', x1))

    if self.cond is not None:  # Optional
      x2 = self.cond.AbbreviatedTree()
      L.append(Field('cond', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class NamedArg(pybase.CompoundObj):
  _type_tag = 91
  __slots__ = ('name', 'value')

  def __init__(self, name, value):
    # type: (Optional[Token], expr_t) -> None
    self.name = name
    self.value = value

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> NamedArg
    return NamedArg(cast('Optional[Token]', None), cast(expr_t, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('NamedArg')
    L = out_node.fields

    if self.name is not None:  # Optional
      x0 = self.name.PrettyTree()
      L.append(Field('name', x0))

    assert self.value is not None
    x1 = self.value.PrettyTree()
    L.append(Field('value', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('NamedArg')
    L = out_node.fields
    if self.name is not None:  # Optional
      x0 = self.name.AbbreviatedTree()
      L.append(Field('name', x0))

    assert self.value is not None
    x1 = self.value.AbbreviatedTree()
    L.append(Field('value', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class Subscript(place_expr_t, expr_t):
  _type_tag = 92
  __slots__ = ('obj', 'index')

  def __init__(self, obj, index):
    # type: (expr_t, expr_t) -> None
    self.obj = obj
    self.index = index

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> Subscript
    return Subscript(cast(expr_t, None), cast(expr_t, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Subscript')
    L = out_node.fields

    assert self.obj is not None
    x0 = self.obj.PrettyTree()
    L.append(Field('obj', x0))

    assert self.index is not None
    x1 = self.index.PrettyTree()
    L.append(Field('index', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Subscript')
    L = out_node.fields
    assert self.obj is not None
    x0 = self.obj.AbbreviatedTree()
    L.append(Field('obj', x0))

    assert self.index is not None
    x1 = self.index.AbbreviatedTree()
    L.append(Field('index', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class Attribute(place_expr_t, expr_t):
  _type_tag = 93
  __slots__ = ('obj', 'op', 'attr', 'ctx')

  def __init__(self, obj, op, attr, ctx):
    # type: (expr_t, Token, Token, expr_context_t) -> None
    self.obj = obj
    self.op = op
    self.attr = attr
    self.ctx = ctx

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> Attribute
    return Attribute(cast(expr_t, None), cast(Token, None), cast(Token, None),
                     expr_context_e.Load)

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Attribute')
    L = out_node.fields

    assert self.obj is not None
    x0 = self.obj.PrettyTree()
    L.append(Field('obj', x0))

    assert self.op is not None
    x1 = self.op.PrettyTree()
    L.append(Field('op', x1))

    assert self.attr is not None
    x2 = self.attr.PrettyTree()
    L.append(Field('attr', x2))

    x3 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(Field('ctx', x3))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('Attribute')
    L = out_node.fields
    assert self.obj is not None
    x0 = self.obj.AbbreviatedTree()
    L.append(Field('obj', x0))

    assert self.op is not None
    x1 = self.op.AbbreviatedTree()
    L.append(Field('op', x1))

    assert self.attr is not None
    x2 = self.attr.AbbreviatedTree()
    L.append(Field('attr', x2))

    x3 = hnode.Leaf(expr_context_str(self.ctx), color_e.TypeName)
    L.append(Field('ctx', x3))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class PosixClass(class_literal_term_t, char_class_term_t, re_t):
  _type_tag = 94
  __slots__ = ('negated', 'name')

  def __init__(self, negated, name):
    # type: (Optional[Token], str) -> None
    self.negated = negated
    self.name = name

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> PosixClass
    return PosixClass(cast('Optional[Token]', None), '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('PosixClass')
    L = out_node.fields

    if self.negated is not None:  # Optional
      x0 = self.negated.PrettyTree()
      L.append(Field('negated', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('PosixClass')
    L = out_node.fields
    if self.negated is not None:  # Optional
      x0 = self.negated.AbbreviatedTree()
      L.append(Field('negated', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class PerlClass(class_literal_term_t, char_class_term_t, re_t):
  _type_tag = 95
  __slots__ = ('negated', 'name')

  def __init__(self, negated, name):
    # type: (Optional[Token], str) -> None
    self.negated = negated
    self.name = name

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> PerlClass
    return PerlClass(cast('Optional[Token]', None), '')

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('PerlClass')
    L = out_node.fields

    if self.negated is not None:  # Optional
      x0 = self.negated.PrettyTree()
      L.append(Field('negated', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('PerlClass')
    L = out_node.fields
    if self.negated is not None:  # Optional
      x0 = self.negated.AbbreviatedTree()
      L.append(Field('negated', x0))

    x1 = NewLeaf(self.name, color_e.StringConst)
    L.append(Field('name', x1))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

class CharCode(char_class_term_t):
  _type_tag = 96
  __slots__ = ('i', 'u_braced', 'blame_tok')

  def __init__(self, i, u_braced, blame_tok):
    # type: (int, bool, Token) -> None
    self.i = i
    self.u_braced = u_braced
    self.blame_tok = blame_tok

  @staticmethod
  def CreateNull(alloc_lists=False):
    # type: () -> CharCode
    return CharCode(-1, False, cast(Token, None))

  def PrettyTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CharCode')
    L = out_node.fields

    x0 = hnode.Leaf(str(self.i), color_e.OtherConst)
    L.append(Field('i', x0))

    x1 = hnode.Leaf('T' if self.u_braced else 'F', color_e.OtherConst)
    L.append(Field('u_braced', x1))

    assert self.blame_tok is not None
    x2 = self.blame_tok.PrettyTree()
    L.append(Field('blame_tok', x2))

    return out_node

  def _AbbreviatedTree(self):
    # type: () -> hnode_t
    out_node = NewRecord('CharCode')
    L = out_node.fields
    x0 = hnode.Leaf(str(self.i), color_e.OtherConst)
    L.append(Field('i', x0))

    x1 = hnode.Leaf('T' if self.u_braced else 'F', color_e.OtherConst)
    L.append(Field('u_braced', x1))

    assert self.blame_tok is not None
    x2 = self.blame_tok.AbbreviatedTree()
    L.append(Field('blame_tok', x2))

    return out_node

  def AbbreviatedTree(self):
    # type: () -> hnode_t
    return self._AbbreviatedTree()

#
# CONCATENATED FILE
#

"""
syntax_abbrev.py - Abbreviations for pretty-printing syntax.asdl.

This module is not used directly, but is combined with generated code.
"""

from _devbuild.gen.id_kind_asdl import Id
from _devbuild.gen.hnode_asdl import hnode_t
from asdl import runtime


def _AbbreviateToken(tok, out):
    # type: (Token, List[hnode_t]) -> None
    if tok.id != Id.Lit_Chars:
        n1 = runtime.NewLeaf(Id_str(tok.id), color_e.OtherConst)
        out.append(n1)

    n2 = runtime.NewLeaf(tok.tval, color_e.StringConst)
    out.append(n2)


def _Token(obj):
    # type: (Token) -> hnode_t
    p_node = runtime.NewRecord('')  # don't show node type
    p_node.abbrev = True

    p_node.left = '<'
    p_node.right = '>'
    _AbbreviateToken(obj, p_node.unnamed_fields)
    return p_node


def _CompoundWord(obj):
    # type: (CompoundWord) -> hnode_t
    p_node = runtime.NewRecord('')  # don't show node type
    p_node.abbrev = True
    p_node.left = '{'
    p_node.right = '}'

    for part in obj.parts:
        p_node.unnamed_fields.append(part.AbbreviatedTree())
    return p_node


def _DoubleQuoted(obj):
    # type: (DoubleQuoted) -> hnode_t
    if obj.left.id != Id.Left_DoubleQuote:
        return None  # Fall back on obj._AbbreviatedTree()

    p_node = runtime.NewRecord('DQ')
    p_node.abbrev = True

    for part in obj.parts:
        p_node.unnamed_fields.append(part.AbbreviatedTree())
    return p_node


def _SingleQuoted(obj):
    # type: (SingleQuoted) -> hnode_t

    # Only abbreviate 'foo', not $'foo\n' or r'foo'
    if obj.left.id != Id.Left_SingleQuote:
        return None  # Fall back on obj._AbbreviatedTree()

    p_node = runtime.NewRecord('SQ')
    p_node.abbrev = True

    for token in obj.tokens:
        p_node.unnamed_fields.append(token.AbbreviatedTree())
    return p_node


def _SimpleVarSub(obj):
    # type: (SimpleVarSub) -> hnode_t
    p_node = runtime.NewRecord('$')
    p_node.abbrev = True

    if obj.left.id != Id.VSub_Name:
        n1 = runtime.NewLeaf(Id_str(obj.left.id), color_e.OtherConst)
        p_node.unnamed_fields.append(n1)

    n2 = runtime.NewLeaf(obj.var_name, color_e.StringConst)
    p_node.unnamed_fields.append(n2)

    return p_node


def _BracedVarSub(obj):
    # type: (BracedVarSub) -> hnode_t
    p_node = runtime.NewRecord('${')
    if obj.prefix_op or obj.bracket_op or obj.suffix_op:
        return None  # we have other fields to display; don't abbreviate

    p_node.abbrev = True
    _AbbreviateToken(obj.token, p_node.unnamed_fields)
    return p_node


def _command__Simple(obj):
    # type: (command.Simple) -> hnode_t
    p_node = runtime.NewRecord('C')
    if (obj.redirects or obj.more_env or obj.typed_args or obj.block or
            obj.do_fork == False):
        return None  # we have other fields to display; don't abbreviate

    p_node.abbrev = True

    for w in obj.words:
        p_node.unnamed_fields.append(w.AbbreviatedTree())
    return p_node


def _expr__Var(obj):
    # type: (expr.Var) -> hnode_t
    p_node = runtime.NewRecord('Var')
    p_node.abbrev = True

    assert obj.name.id == Id.Expr_Name, obj.name
    n1 = runtime.NewLeaf(obj.name.tval, color_e.StringConst)
    p_node.unnamed_fields.append(n1)
    return p_node


def _expr__Const(obj):
    # type: (expr.Const) -> hnode_t
    p_node = runtime.NewRecord('Const')
    p_node.abbrev = True

    tok = obj.c
    out = p_node.unnamed_fields

    n1 = runtime.NewLeaf(Id_str(tok.id), color_e.OtherConst)
    out.append(n1)

    n2 = runtime.NewLeaf(tok.tval, color_e.StringConst)
    out.append(n2)
    return p_node
